package testkinectv2;

public class H_Kinect {
	/*
	#define BODY_COUNT 6
	 */
	static final int BODY_COUNT = 6;
	
	/*
	enum _FrameSourceTypes
	    {
	        FrameSourceTypes_None	= 0,
	        FrameSourceTypes_Color	= 0x1,
	        FrameSourceTypes_Infrared	= 0x2,
	        FrameSourceTypes_LongExposureInfrared	= 0x4,
	        FrameSourceTypes_Depth	= 0x8,
	        FrameSourceTypes_BodyIndex	= 0x10,
	        FrameSourceTypes_Body	= 0x20,
	        FrameSourceTypes_Audio	= 0x40
	    } ;
	 */
	static final int
	    FrameSourceTypes_None					= 0,
	    FrameSourceTypes_Color					= 0x1,
	    FrameSourceTypes_Infrared				= 0x2,
	    FrameSourceTypes_LongExposureInfrared	= 0x4,
	    FrameSourceTypes_Depth					= 0x8,
	    FrameSourceTypes_BodyIndex				= 0x10,
	    FrameSourceTypes_Body					= 0x20,
	    FrameSourceTypes_Audio					= 0x40;
	
	/*
	enum _ColorImageFormat
	    {
	        ColorImageFormat_None	= 0,
	        ColorImageFormat_Rgba	= 1,
	        ColorImageFormat_Yuv	= 2,
	        ColorImageFormat_Bgra	= 3,
	        ColorImageFormat_Bayer	= 4,
	        ColorImageFormat_Yuy2	= 5
	    } ;
	 */
	static final int
	    ColorImageFormat_None	= 0,
	    ColorImageFormat_Rgba	= 1,
	    ColorImageFormat_Yuv	= 2,
	    ColorImageFormat_Bgra	= 3,
	    ColorImageFormat_Bayer	= 4,
	    ColorImageFormat_Yuy2	= 5;

	/*
	enum _JointType
	    {
	        JointType_SpineBase	= 0,
	        JointType_SpineMid	= 1,
	        JointType_Neck	= 2,
	        JointType_Head	= 3,
	        JointType_ShoulderLeft	= 4,
	        JointType_ElbowLeft	= 5,
	        JointType_WristLeft	= 6,
	        JointType_HandLeft	= 7,
	        JointType_ShoulderRight	= 8,
	        JointType_ElbowRight	= 9,
	        JointType_WristRight	= 10,
	        JointType_HandRight	= 11,
	        JointType_HipLeft	= 12,
	        JointType_KneeLeft	= 13,
	        JointType_AnkleLeft	= 14,
	        JointType_FootLeft	= 15,
	        JointType_HipRight	= 16,
	        JointType_KneeRight	= 17,
	        JointType_AnkleRight	= 18,
	        JointType_FootRight	= 19,
	        JointType_SpineShoulder	= 20,
	        JointType_HandTipLeft	= 21,
	        JointType_ThumbLeft	= 22,
	        JointType_HandTipRight	= 23,
	        JointType_ThumbRight	= 24,
	        JointType_Count	= ( JointType_ThumbRight + 1 ) 
	    } ;
	 */
	static final int
	    JointType_SpineBase	    = 0,
	    JointType_SpineMid	    = 1,
	    JointType_Neck	        = 2,
	    JointType_Head	        = 3,
	    JointType_ShoulderLeft	= 4,
	    JointType_ElbowLeft	    = 5,
	    JointType_WristLeft	    = 6,
	    JointType_HandLeft	    = 7,
	    JointType_ShoulderRight	= 8,
	    JointType_ElbowRight	= 9,
	    JointType_WristRight	= 10,
	    JointType_HandRight	    = 11,
	    JointType_HipLeft	    = 12,
	    JointType_KneeLeft	    = 13,
	    JointType_AnkleLeft	    = 14,
	    JointType_FootLeft	    = 15,
	    JointType_HipRight	    = 16,
	    JointType_KneeRight	    = 17,
	    JointType_AnkleRight	= 18,
	    JointType_FootRight	    = 19,
	    JointType_SpineShoulder	= 20,
	    JointType_HandTipLeft	= 21,
	    JointType_ThumbLeft	    = 22,
	    JointType_HandTipRight	= 23,
	    JointType_ThumbRight	= 24,
	    JointType_Count	        = ( JointType_ThumbRight + 1 );
	
	/*
	enum _TrackingState
	    {
	        TrackingState_NotTracked	= 0,
	        TrackingState_Inferred	= 1,
	        TrackingState_Tracked	= 2
	    } ;
	 */
	static final int
	    TrackingState_NotTracked	= 0,
	    TrackingState_Inferred	    = 1,
	    TrackingState_Tracked	    = 2;
	
	/*
	enum _TrackingConfidence
	    {
	        TrackingConfidence_Low	= 0,
	        TrackingConfidence_High	= 1
	    } ;
	 */
	static final int
	    TrackingConfidence_Low	= 0,
	    TrackingConfidence_High	= 1;
	
	/*
	enum _HandState
	    {
	        HandState_Unknown	= 0,
	        HandState_NotTracked	= 1,
	        HandState_Open	= 2,
	        HandState_Closed	= 3,
	        HandState_Lasso	= 4
	    } ;
   	 */
	static final int
	    HandState_Unknown	    = 0,
	    HandState_NotTracked	= 1,
	    HandState_Open	        = 2,
	    HandState_Closed	    = 3,
	    HandState_Lasso	        = 4;
	
	/*
	enum _Activity
	    {
	        Activity_EyeLeftClosed	= 0,
	        Activity_EyeRightClosed	= 1,
	        Activity_MouthOpen	= 2,
	        Activity_MouthMoved	= 3,
	        Activity_LookingAway	= 4,
	        Activity_Count	= ( Activity_LookingAway + 1 ) 
	    } ;
   	 */
	static final int
	    Activity_EyeLeftClosed	= 0,
	    Activity_EyeRightClosed	= 1,
	    Activity_MouthOpen	    = 2,
	    Activity_MouthMoved	    = 3,
	    Activity_LookingAway	= 4,
	    Activity_Count          = ( Activity_LookingAway + 1 );
	
	/*
	enum _Appearance
	    {
	        Appearance_WearingGlasses	= 0,
	        Appearance_Count	= ( Appearance_WearingGlasses + 1 ) 
	    } ;
   	 */
	static final int
	    Appearance_WearingGlasses	= 0,
	    Appearance_Count            = ( Appearance_WearingGlasses + 1 );
	
	/*
	enum _Expression
	    {
	        Expression_Neutral	= 0,
	        Expression_Happy	= 1,
	        Expression_Count	= ( Expression_Happy + 1 ) 
	    } ;
	 */
	static final int
	    Expression_Neutral	= 0,
	    Expression_Happy	= 1,
	    Expression_Count    = ( Expression_Happy + 1 );
	
	/*
	enum _DetectionResult
	    {
	        DetectionResult_Unknown	= 0,
	        DetectionResult_No	= 1,
	        DetectionResult_Maybe	= 2,
	        DetectionResult_Yes	= 3
	    } ;
     */
	static final int
	    DetectionResult_Unknown	= 0,
	    DetectionResult_No	    = 1,
	    DetectionResult_Maybe	= 2,
	    DetectionResult_Yes	    = 3;
	
	/*
	enum _HandType
	    {
	        HandType_NONE	= 0,
	        HandType_LEFT	= ( HandType_NONE + 1 ) ,
	        HandType_RIGHT	= ( HandType_LEFT + 1 ) 
	    } ;
	 */
	static final int
	    HandType_NONE	= 0,
	    HandType_LEFT	= ( HandType_NONE + 1 ),
	    HandType_RIGHT	= ( HandType_LEFT + 1 ); 
	
}
