package testkinectv2;

public class H_NuiKinectFusionDepthProcessor {
	/*
	// Default processing parameters
	#define NUI_FUSION_DEFAULT_MINIMUM_DEPTH (0.5f)
	#define NUI_FUSION_DEFAULT_MAXIMUM_DEPTH (8.0f)
	
	#define NUI_FUSION_DEFAULT_SMOOTHING_KERNEL_WIDTH (2)
	#define NUI_FUSION_DEFAULT_SMOOTHING_DISTANCE_THRESHOLD (0.04f)
	
	#define NUI_FUSION_DEFAULT_ALIGN_ITERATION_COUNT (20)
	
	#define NUI_FUSION_DEFAULT_INTEGRATION_WEIGHT (200)
	
	#define NUI_FUSION_DEFAULT_COLOR_INTEGRATION_OF_ALL_ANGLES (180.0f) // Integrate +/- 180 degrees
	 */
	static final float NUI_FUSION_DEFAULT_MINIMUM_DEPTH = 0.5f;
	static final float NUI_FUSION_DEFAULT_MAXIMUM_DEPTH = 8.0f;

	static final int NUI_FUSION_DEFAULT_SMOOTHING_KERNEL_WIDTH = 2;
	static final float NUI_FUSION_DEFAULT_SMOOTHING_DISTANCE_THRESHOLD = 0.04f;
	
	static final int NUI_FUSION_DEFAULT_ALIGN_ITERATION_COUNT = 20;
	
	static final int NUI_FUSION_DEFAULT_INTEGRATION_WEIGHT = 200;

	static final float NUI_FUSION_DEFAULT_COLOR_INTEGRATION_OF_ALL_ANGLES = 180.0f;

	/*
	// Default Kinect intrinsic camera parameters, normalized by image size, 
	// based on Kinect for Windows SDK values
	#define NUI_KINECT_DEPTH_NORM_FOCAL_LENGTH_X (0.72113f)
	#define NUI_KINECT_DEPTH_NORM_FOCAL_LENGTH_Y (0.870799f)
	#define NUI_KINECT_DEPTH_NORM_PRINCIPAL_POINT_X (0.50602675f)
	#define NUI_KINECT_DEPTH_NORM_PRINCIPAL_POINT_Y (0.499133f)
	 */
	static final float NUI_KINECT_DEPTH_NORM_FOCAL_LENGTH_X = 0.72113f;
	static final float NUI_KINECT_DEPTH_NORM_FOCAL_LENGTH_Y = 0.870799f;
	static final float NUI_KINECT_DEPTH_NORM_PRINCIPAL_POINT_X = 0.50602675f;
	static final float NUI_KINECT_DEPTH_NORM_PRINCIPAL_POINT_Y = 0.499133f;
	
	
}
