package testkinectv2;

import utildll.*;

public class Wrp_IAudioBeam {
	private static final int CHARSET = Arg.UNICODE;
	private long beam = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_AudioSource = 3,
			IDX_get_AudioBeamMode = 4,
			IDX_put_AudioBeamMode = 5,
			IDX_get_BeamAngle = 6,
			IDX_put_BeamAngle = 7,
			IDX_get_BeamAngleConfidence = 8,
			IDX_OpenInputStream = 9,
			IDX_get_RelativeTime = 10;
	
	public Wrp_IAudioBeam(long beam) {
		this.beam = beam;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(beam, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_BeamAngle(
	         float *beamAngle
	)
	 */
	private class Arg_get_BeamAngle extends Arg_property {
		private float[] beamAngle;
		
		private Arg_get_BeamAngle(float[] beamAngle) {
			this.beamAngle = beamAngle;
		}
	}

	public int get_BeamAngle(float[] beamAngle) throws Exception_KINECT {
		Arg_get_BeamAngle arg = new Arg_get_BeamAngle(beamAngle);

		int intRtn = JInvoker.callIntMethod(beam, IDX_get_BeamAngle, arg);
		
		System.out.println("get_BeamAngle rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BeamAngle");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BeamAngle");

		return intRtn;
	}

	/*
	HRESULT get_BeamAngleConfidence(
	         float *beamAngleConfidence
	)
	 */
	private class Arg_get_BeamAngleConfidence extends Arg_property {
		private float[] beamAngleConfidence;
		
		private Arg_get_BeamAngleConfidence(float[] beamAngleConfidence) {
			this.beamAngleConfidence = beamAngleConfidence;
		}
	}

	public int get_BeamAngleConfidence(float[] beamAngleConfidence) throws Exception_KINECT {
		Arg_get_BeamAngleConfidence arg = new Arg_get_BeamAngleConfidence(beamAngleConfidence);

		int intRtn = JInvoker.callIntMethod(beam, IDX_get_BeamAngleConfidence, arg);
		
		System.out.println("get_BeamAngleConfidence rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BeamAngleConfidence");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BeamAngleConfidence");

		return intRtn;
	}

}
