package testkinectv2;

import utildll.*;

public class Wrp_IAudioBeamSubFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_FrameLengthInBytes = 3,
			IDX_get_Duration = 4,
			IDX_get_BeamAngle = 5,
			IDX_get_BeamAngleConfidence = 6,
			IDX_get_AudioBeamMode = 7,
			IDX_get_AudioBodyCorrelationCount = 8,
			IDX_GetAudioBodyCorrelation = 9,
			IDX_CopyFrameDataToArray = 10,
			IDX_AccessUnderlyingBuffer = 11,
			IDX_get_RelativeTime = 12;
	
	public Wrp_IAudioBeamSubFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT get_AudioBodyCorrelationCount(
	         UINT32 *pCount
	)
	 */
	private class Arg_get_AudioBodyCorrelationCount extends Arg_property {
		private int[] pCount;
		
		Arg_get_AudioBodyCorrelationCount(int[] pCount) {
			this.pCount = pCount;
		}
	}
	
	public int get_AudioBodyCorrelationCount(int[] pCount) throws Exception_KINECT {
		Arg_get_AudioBodyCorrelationCount arg = new Arg_get_AudioBodyCorrelationCount(pCount);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_AudioBodyCorrelationCount, arg);
		
		System.out.println("get_AudioBodyCorrelationCount rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_AudioBodyCorrelationCount");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_AudioBodyCorrelationCount");
		
		return intRtn;
	}
	
	/*
	HRESULT GetAudioBodyCorrelation(
	         UINT index,
	         IAudioBodyCorrelation **ppAudioBodyCorrelation
	)
	 */
	private class Arg_GetAudioBodyCorrelation extends Arg_property {
		private int index;
		private long[] ppAudioBodyCorrelation;
		
		Arg_GetAudioBodyCorrelation(int index, long[] ppAudioBodyCorrelation) {
			this.index = index;
			this.ppAudioBodyCorrelation = ppAudioBodyCorrelation;
		}
	}
	
	public int GetAudioBodyCorrelation(int index, long[] ppAudioBodyCorrelation) throws Exception_KINECT {
		Arg_GetAudioBodyCorrelation arg = new Arg_GetAudioBodyCorrelation(index, ppAudioBodyCorrelation);

		int intRtn = JInvoker.callIntMethod(frame, IDX_GetAudioBodyCorrelation, arg);
		
		System.out.println("GetAudioBodyCorrelation rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetAudioBodyCorrelation");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetAudioBodyCorrelation");
		
		return intRtn;
	}

}
