package testkinectv2;

import utildll.*;

public class Wrp_IColorFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_RawColorImageFormat = 3,
			IDX_get_FrameDescription = 4,
			IDX_CopyRawFrameDataToArray = 5,
			IDX_AccessRawUnderlyingBuffer = 6,
			IDX_CopyConvertedFrameDataToArray = 7,
			IDX_CreateFrameDescription = 8,
			IDX_get_ColorCameraSettings = 9,
			IDX_get_RelativeTime = 10,
			IDX_get_ColorFrameSource = 11;
	
	public Wrp_IColorFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT CopyConvertedFrameDataToArray(
	         UINT capacity,
	         BYTE *frameData,
	         ColorImageFormat colorFormat
	)
	 */
	private class Arg_CopyConvertedFrameDataToArray extends Arg_property {
		private int capacity;
		private int[] frameData; // BYTE *
		private int colorFormat;
		
		Arg_CopyConvertedFrameDataToArray(int capacity, int[] frameData, int colorFormat) {
			this.capacity = capacity;
			this.frameData = frameData;
			this.colorFormat = colorFormat;
		}
	}
	
	public int CopyConvertedFrameDataToArray(int capacity, int[] frameData, int colorFormat) throws Exception_KINECT {
		Arg_CopyConvertedFrameDataToArray arg = new Arg_CopyConvertedFrameDataToArray(capacity, frameData, colorFormat);

		int intRtn = JInvoker.callIntMethod(frame, IDX_CopyConvertedFrameDataToArray, arg);
		
		System.out.println("CopyConvertedFrameDataToArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CopyConvertedFrameDataToArray");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CopyConvertedFrameDataToArray");
		
		return intRtn;
	}

}
