package testkinectv2;

import utildll.*;

public class Wrp_IFaceFrameResult {
	private static final int CHARSET = Arg.UNICODE;
	private long result = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_RelativeTime = 3,
			IDX_get_FaceFrameFeatures = 4,
			IDX_get_TrackingId = 5,
			IDX_get_FaceRotationQuaternion = 6,
			IDX_get_FaceBoundingBoxInColorSpace = 7,
			IDX_get_FaceBoundingBoxInInfraredSpace = 8,
			IDX_GetFacePointsInColorSpace = 9,
			IDX_GetFacePointsInInfraredSpace = 10,
			IDX_GetFaceProperties = 11;
	
	public Wrp_IFaceFrameResult(long result) {
		this.result = result;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(result, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_FaceRotationQuaternion(
	         Vector4 *rotationQuaternion
	)
	 */
	private class Arg_get_FaceRotationQuaternion extends Arg_property {
		private Struct_Vector4 rotationQuaternion;
		
		private Arg_get_FaceRotationQuaternion(Struct_Vector4 rotationQuaternion) {
			this.rotationQuaternion = rotationQuaternion;
		}
	}

	public int get_FaceRotationQuaternion(Struct_Vector4 rotationQuaternion) throws Exception_KINECT {
		Arg_get_FaceRotationQuaternion arg = new Arg_get_FaceRotationQuaternion(rotationQuaternion);

		int intRtn = JInvoker.callIntMethod(result, IDX_get_FaceRotationQuaternion, arg);
		
		System.out.println("get_FaceRotationQuaternion rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_FaceRotationQuaternion");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_FaceRotationQuaternion");

		return intRtn;
	}
	
	/*
	HRESULT get_FaceBoundingBoxInColorSpace(
	         RectI *boundingBox
	)
	 */
	private class Arg_get_FaceBoundingBoxInColorSpace extends Arg_property {
		private Struct_RectI boundingBox;
		
		private Arg_get_FaceBoundingBoxInColorSpace(Struct_RectI boundingBox) {
			this.boundingBox = boundingBox;
		}
	}

	public int get_FaceBoundingBoxInColorSpace(Struct_RectI boundingBox) throws Exception_KINECT {
		Arg_get_FaceBoundingBoxInColorSpace arg = new Arg_get_FaceBoundingBoxInColorSpace(boundingBox);

		int intRtn = JInvoker.callIntMethod(result, IDX_get_FaceBoundingBoxInColorSpace, arg);
		
		System.out.println("get_FaceBoundingBoxInColorSpace rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_FaceBoundingBoxInColorSpace");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_FaceBoundingBoxInColorSpace");

		return intRtn;
	}
	
	/*
	HRESULT GetFacePointsInColorSpace(
	         const UINT capacity,
	         PointF *facePoints
	)
	 */
	private class Arg_GetFacePointsInColorSpace extends Arg_property {
		private int capacity;
		private Struct_PointF[] facePoints;
		
		private Arg_GetFacePointsInColorSpace(int capacity, Struct_PointF[] facePoints) {
			this.capacity = capacity;
			this.facePoints = facePoints;
		}
	}

	public int GetFacePointsInColorSpace(int capacity, Struct_PointF[] facePoints) throws Exception_KINECT {
		Arg_GetFacePointsInColorSpace arg = new Arg_GetFacePointsInColorSpace(capacity, facePoints);

		int intRtn = JInvoker.callIntMethod(result, IDX_GetFacePointsInColorSpace, arg);
		
		System.out.println("GetFacePointsInColorSpace rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetFacePointsInColorSpace");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetFacePointsInColorSpace");

		return intRtn;
	}

	/*
	HRESULT GetFaceProperties(
	         const UINT capacity,
	         DetectionResult *detectionResults
	)
	 */
	private class Arg_GetFaceProperties extends Arg_property {
		private int capacity;
		private int[] detectionResults;
		
		private Arg_GetFaceProperties(int capacity, int[] detectionResults) {
			this.capacity = capacity;
			this.detectionResults = detectionResults;
		}
	}

	public int GetFaceProperties(int capacity, int[] detectionResults) throws Exception_KINECT {
		Arg_GetFaceProperties arg = new Arg_GetFaceProperties(capacity, detectionResults);

		int intRtn = JInvoker.callIntMethod(result, IDX_GetFaceProperties, arg);
		
		System.out.println("GetFaceProperties rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetFaceProperties");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetFaceProperties");

		return intRtn;
	}
	
}
