package testkinectv2;

import utildll.*;

public class Wrp_IFaceModelBuilder {
	private static final int CHARSET = Arg.UNICODE;
	private long builder = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeCollectionStatusChanged = 3,
			IDX_UnsubscribeCollectionStatusChanged = 4,
			IDX_GetCollectionStatusChangedEventData = 5,
			IDX_SubscribeCaptureStatusChanged = 6,
			IDX_UnsubscribeCaptureStatusChanged = 7,
			IDX_GetCaptureStatusChangedEventData = 8,
			IDX_get_CollectionStatus = 9,
			IDX_get_CaptureStatus = 10,
			IDX_BeginFaceDataCollection = 11,
			IDX_GetFaceData = 12;
	
	public Wrp_IFaceModelBuilder(long builder) {
		this.builder = builder;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(builder, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_CollectionStatus(
	         FaceModelBuilderCollectionStatus *currrentCollectionStatus
	)
	 */
	private class Arg_get_CollectionStatus extends Arg_property {
		private int[] currrentCollectionStatus;
		
		private Arg_get_CollectionStatus(int[] currrentCollectionStatus) {
			this.currrentCollectionStatus = currrentCollectionStatus;
		}
	}

	public int get_CollectionStatus(int[] currrentCollectionStatus) throws Exception_KINECT {
		Arg_get_CollectionStatus arg = new Arg_get_CollectionStatus(currrentCollectionStatus);

		int intRtn = JInvoker.callIntMethod(builder, IDX_get_CollectionStatus, arg);
		
		System.out.println("get_CollectionStatus rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_CollectionStatus");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_CollectionStatus");

		return intRtn;
	}
	
	/*
	HRESULT get_CaptureStatus(
	         FaceModelBuilderCaptureStatus *currentCaptureStatus
	)
	 */
	private class Arg_get_CaptureStatus extends Arg_property {
		private int[] currentCaptureStatus;
		
		private Arg_get_CaptureStatus(int[] currentCaptureStatus) {
			this.currentCaptureStatus = currentCaptureStatus;
		}
	}

	public int get_CaptureStatus(int[] currentCaptureStatus) throws Exception_KINECT {
		Arg_get_CaptureStatus arg = new Arg_get_CaptureStatus(currentCaptureStatus);

		int intRtn = JInvoker.callIntMethod(builder, IDX_get_CaptureStatus, arg);
		
		System.out.println("get_CaptureStatus rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_CaptureStatus");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_CaptureStatus");

		return intRtn;
	}
	
	/*
	HRESULT BeginFaceDataCollection()
	 */
	private class Arg_BeginFaceDataCollection extends Arg_property {
	}

	public int BeginFaceDataCollection() throws Exception_KINECT {
		Arg_BeginFaceDataCollection arg = new Arg_BeginFaceDataCollection();

		int intRtn = JInvoker.callIntMethod(builder, IDX_BeginFaceDataCollection, arg);
		
		System.out.println("BeginFaceDataCollection rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("BeginFaceDataCollection");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("BeginFaceDataCollection");

		return intRtn;
	}
	
	/*
	HRESULT GetFaceData(
	         IFaceModelData **faceModelData
	)
	 */
	private class Arg_GetFaceData extends Arg_property {
		private long[] faceModelData;
		
		private Arg_GetFaceData(long[] faceModelData) {
			this.faceModelData = faceModelData;
		}
	}

	public int GetFaceData(long[] faceModelData) throws Exception_KINECT {
		Arg_GetFaceData arg = new Arg_GetFaceData(faceModelData);

		int intRtn = JInvoker.callIntMethod(builder, IDX_GetFaceData, arg);
		
		System.out.println("GetFaceData rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetFaceData");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetFaceData");

		return intRtn;
	}
	

}
