package testkinectv2;

import utildll.*;

public class Wrp_IFaceModelData {
	private static final int CHARSET = Arg.UNICODE;
	private long data = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_ProduceFaceModel = 3;
	
	public Wrp_IFaceModelData(long data) {
		this.data = data;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(data, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT ProduceFaceModel(
	         IFaceModel **faceModel
	)
	 */
	private class Arg_ProduceFaceModel extends Arg_property {
		private long[] faceModel;
		
		private Arg_ProduceFaceModel(long[] faceModel) {
			this.faceModel = faceModel;
		}
	}

	public int ProduceFaceModel(long[] faceModel) throws Exception_KINECT {
		Arg_ProduceFaceModel arg = new Arg_ProduceFaceModel(faceModel);

		int intRtn = JInvoker.callIntMethod(data, IDX_ProduceFaceModel, arg);
		
		System.out.println("ProduceFaceModel rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("ProduceFaceModel");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ProduceFaceModel");

		return intRtn;
	}

}
