package testkinectv2;

import utildll.*;

public class Wrp_IHighDefinitionFaceFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_RelativeTime = 3,
			IDX_get_HighDefinitionFaceFrameSource = 4,
			IDX_get_BodyFrameReference = 5,
			IDX_get_ColorFrameReference = 6,
			IDX_get_DepthFrameReference = 7,
			IDX_get_InfraredFrameReference = 8,
			IDX_get_IsTrackingIdValid = 9,
			IDX_get_IsFaceTracked = 10,
			IDX_get_TrackingId = 11,
			IDX_get_FaceModel = 12,
			IDX_get_FaceAlignmentQuality = 13,
			IDX_GetAndRefreshFaceAlignmentResult = 14;
	
	public Wrp_IHighDefinitionFaceFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_IsTrackingIdValid(
	         BOOLEAN *isTrackingIdValid
	)
	 */
	private class Arg_get_IsTrackingIdValid extends Arg_property {
		private byte[] isTrackingIdValid;
		
		private Arg_get_IsTrackingIdValid(byte[] isTrackingIdValid) {
			this.isTrackingIdValid = isTrackingIdValid;
		}
	}

	public int get_IsTrackingIdValid(byte[] isTrackingIdValid) throws Exception_KINECT {
		Arg_get_IsTrackingIdValid arg = new Arg_get_IsTrackingIdValid(isTrackingIdValid);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_IsTrackingIdValid, arg);
		
		System.out.println("get_IsTrackingIdValid rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsTrackingIdValid");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsTrackingIdValid");

		return intRtn;
	}

	/*
	HRESULT get_IsFaceTracked(
	         BOOLEAN *isFaceTracked
	)
	 */
	private class Arg_get_IsFaceTracked extends Arg_property {
		private byte[] isFaceTracked;
		
		private Arg_get_IsFaceTracked(byte[] isFaceTracked) {
			this.isFaceTracked = isFaceTracked;
		}
	}

	public int get_IsFaceTracked(byte[] isFaceTracked) throws Exception_KINECT {
		Arg_get_IsFaceTracked arg = new Arg_get_IsFaceTracked(isFaceTracked);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_IsFaceTracked, arg);
		
		System.out.println("get_IsFaceTracked rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsFaceTracked");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsFaceTracked");

		return intRtn;
	}
	
	/*
	HRESULT GetAndRefreshFaceAlignmentResult(
	         IFaceAlignment *faceAlignmentResults
	)
	 */
	private class Arg_GetAndRefreshFaceAlignmentResult extends Arg_property {
		private long faceAlignmentResults;
		
		private Arg_GetAndRefreshFaceAlignmentResult(long faceAlignmentResults) {
			this.faceAlignmentResults = faceAlignmentResults;
		}
	}

	public int GetAndRefreshFaceAlignmentResult(long faceAlignmentResults) throws Exception_KINECT {
		Arg_GetAndRefreshFaceAlignmentResult arg = new Arg_GetAndRefreshFaceAlignmentResult(faceAlignmentResults);

		int intRtn = JInvoker.callIntMethod(frame, IDX_GetAndRefreshFaceAlignmentResult, arg);
		
		System.out.println("GetAndRefreshFaceAlignmentResult rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetAndRefreshFaceAlignmentResult");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetAndRefreshFaceAlignmentResult");

		return intRtn;
	}
	
	
}
