package testkinectv2;

import utildll.*;

public class Wrp_IInfraredFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_CopyFrameDataToArray = 3,
			IDX_AccessUnderlyingBuffer = 4,
			IDX_get_FrameDescription = 5,
			IDX_get_RelativeTime = 6,
			IDX_get_InfraredFrameSource = 7;
	
	public Wrp_IInfraredFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT AccessUnderlyingBuffer(
	         UINT *capacity,
	         UINT16 **buffer
	)
	 */
	private class Arg_AccessUnderlyingBuffer extends Arg_property {
		private int[] capacity;
		private Struct_REF_BUFFER ppBuffer = new Struct_REF_BUFFER();
		
		Arg_AccessUnderlyingBuffer(int[] capacity) {
			this.capacity = capacity;
		}
		
		short[] getBuffer() {return this.ppBuffer.pBuffer;}
	}
	
	private class Struct_REF_BUFFER {
		@_Length_is("capacity") short[] pBuffer = null;
	}
	
	public short[] AccessUnderlyingBuffer(int[] capacity) throws Exception_KINECT {
		Arg_AccessUnderlyingBuffer arg = new Arg_AccessUnderlyingBuffer(capacity);

		int intRtn = JInvoker.callIntMethod(frame, IDX_AccessUnderlyingBuffer, arg);
		
		System.out.println("AccessUnderlyingBuffer rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("AccessUnderlyingBuffer");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("AccessUnderlyingBuffer");
		
		return arg.getBuffer();
	}

}
