package testkinectv2;

import utildll.*;

public class Wrp_IKinectPointerEventArgs {
	private static final int CHARSET = Arg.UNICODE;
	private long args = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_Handled = 3,
			IDX_put_Handled = 4,
			IDX_get_CurrentPoint = 5;
	
	public Wrp_IKinectPointerEventArgs(long args) {
		this.args = args;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(args, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_CurrentPoint(
	         IKinectPointerPoint **pointer
	)
	 */
	private class Arg_get_CurrentPoint extends Arg_property {
		private long[] pointer;
		
		private Arg_get_CurrentPoint(long[] pointer) {
			this.pointer = pointer;
		}
	}

	public int get_CurrentPoint(long[] pointer) throws Exception_KINECT {
		Arg_get_CurrentPoint arg = new Arg_get_CurrentPoint(pointer);

		int intRtn = JInvoker.callIntMethod(args, IDX_get_CurrentPoint, arg);
		
		System.out.println("get_CurrentPoint rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_CurrentPoint");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_CurrentPoint");

		return intRtn;
	}

}
