package testkinectv2;

import utildll.*;

public class Wrp_IKinectPointerPointProperties {
	private static final int CHARSET = Arg.UNICODE;
	private long properties = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_IsPrimary = 3,
			IDX_get_IsInRange = 4,
			IDX_get_IsEngaged = 5,
			IDX_get_BodyTrackingId = 6,
			IDX_get_HandType = 7,
			IDX_get_HandReachExtent = 8,
			IDX_get_BodyTimeCounter = 9,
			IDX_get_HandRotation = 10,
			IDX_get_PressExtent = 11,
			IDX_get_UnclampedPosition = 12;
	
	public Wrp_IKinectPointerPointProperties(long properties) {
		this.properties = properties;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(properties, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_IsInRange(
	         boolean *isInRange
	)
	 */
	private class Arg_get_IsInRange extends Arg_property {
		private byte[] isInRange;
		
		private Arg_get_IsInRange(byte[] isInRange) {
			this.isInRange = isInRange;
		}
	}

	public int get_IsInRange(byte[] isInRange) throws Exception_KINECT {
		Arg_get_IsInRange arg = new Arg_get_IsInRange(isInRange);

		int intRtn = JInvoker.callIntMethod(properties, IDX_get_IsInRange, arg);
		
		System.out.println("get_IsInRange rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsInRange");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsInRange");

		return intRtn;
	}

	/*
	HRESULT get_HandType(
	         HandType *handType
	)
	 */
	private class Arg_get_HandType extends Arg_property {
		private int[] handType;
		
		private Arg_get_HandType(int[] handType) {
			this.handType = handType;
		}
	}

	public int get_HandType(int[] handType) throws Exception_KINECT {
		Arg_get_HandType arg = new Arg_get_HandType(handType);

		int intRtn = JInvoker.callIntMethod(properties, IDX_get_HandType, arg);
		
		System.out.println("get_HandType rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_HandType");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_HandType");

		return intRtn;
	}
	
}
