package testkinectv2;

import utildll.*;

public class Wrp_IMultiSourceFrameReader {
	private static final int CHARSET = Arg.UNICODE;
	private long reader = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeMultiSourceFrameArrived = 3,
			IDX_UnsubscribeMultiSourceFrameArrived = 4,
			IDX_GetMultiSourceFrameArrivedEventData = 5,
			IDX_AcquireLatestFrame = 6,
			IDX_get_FrameSourceTypes = 7,
			IDX_get_IsPaused = 8,
			IDX_put_IsPaused = 9,
			IDX_get_KinectSensor = 10;
	
	public Wrp_IMultiSourceFrameReader(long reader) {
		this.reader = reader;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(reader, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT SubscribeMultiSourceFrameArrived(
	         WAITABLE_HANDLE *waitableHandle
	)
	 */
	private class Arg_SubscribeMultiSourceFrameArrived extends Arg_property {
		private long[] waitableHandle;
		
		private Arg_SubscribeMultiSourceFrameArrived(long[] waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int SubscribeMultiSourceFrameArrived(long[] waitableHandle) throws Exception_KINECT {
		Arg_SubscribeMultiSourceFrameArrived arg = new Arg_SubscribeMultiSourceFrameArrived(waitableHandle);

		int intRtn = JInvoker.callIntMethod(reader, IDX_SubscribeMultiSourceFrameArrived, arg);
		
		System.out.println("SubscribeMultiSourceFrameArrived rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("SubscribeMultiSourceFrameArrived");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SubscribeMultiSourceFrameArrived");

		return intRtn;
	}
	
	/*
	HRESULT UnsubscribeMultiSourceFrameArrived(
	         WAITABLE_HANDLE waitableHandle
	)
	 */
	private class Arg_UnsubscribeMultiSourceFrameArrived extends Arg_property {
		private long waitableHandle;
		
		private Arg_UnsubscribeMultiSourceFrameArrived(long waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int UnsubscribeMultiSourceFrameArrived(long waitableHandle) throws Exception_KINECT {
		Arg_UnsubscribeMultiSourceFrameArrived arg = new Arg_UnsubscribeMultiSourceFrameArrived(waitableHandle);

		int intRtn = JInvoker.callIntMethod(reader, IDX_UnsubscribeMultiSourceFrameArrived, arg);
		
		System.out.println("UnsubscribeMultiSourceFrameArrived rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("UnsubscribeMultiSourceFrameArrived");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("UnsubscribeMultiSourceFrameArrived");

		return intRtn;
	}
	
	/*
	HRESULT GetMultiSourceFrameArrivedEventData(
	         WAITABLE_HANDLE waitableHandle,
	         IMultiSourceFrameArrivedEventArgs **eventData
	)
	 */
	private class Arg_GetMultiSourceFrameArrivedEventData extends Arg_property {
		private long waitableHandle;
		private long[] eventData;
		
		private Arg_GetMultiSourceFrameArrivedEventData(long waitableHandle, long[] eventData) {
			this.waitableHandle = waitableHandle;
			this.eventData = eventData;
		}
	}

	public int GetMultiSourceFrameArrivedEventData(long waitableHandle, long[] eventData) throws Exception_KINECT {
		Arg_GetMultiSourceFrameArrivedEventData arg = new Arg_GetMultiSourceFrameArrivedEventData(waitableHandle,
				eventData);

		int intRtn = JInvoker.callIntMethod(reader, IDX_GetMultiSourceFrameArrivedEventData, arg);
		
		System.out.println("GetMultiSourceFrameArrivedEventData rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetMultiSourceFrameArrivedEventData");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetMultiSourceFrameArrivedEventData");

		return intRtn;
	}
	
	/*
	HRESULT AcquireLatestFrame(
	         IMultiSourceFrame **multiSourceFrame
	)
	 */
	private class Arg_AcquireLatestFrame extends Arg_property {
		private long[] multiSourceFrame;
		
		private Arg_AcquireLatestFrame(long[] multiSourceFrame) {
			this.multiSourceFrame = multiSourceFrame;
		}
	}

	public int AcquireLatestFrame(long[] multiSourceFrame) throws Exception_KINECT {
		Arg_AcquireLatestFrame arg = new Arg_AcquireLatestFrame(multiSourceFrame);

		int intRtn = JInvoker.callIntMethod(reader, IDX_AcquireLatestFrame, arg);
		
		System.out.println("AcquireLatestFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("AcquireLatestFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_WinError.E_PENDING)
				throw new Exception_KINECT("AcquireLatestFrame");

		return intRtn;
	}

}
