package testkinectv2;

import utildll.*;

public class Wrp_IMultiSourceFrameReference {
	private static final int CHARSET = Arg.UNICODE;
	private long reference = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_AcquireFrame = 3;
	
	public Wrp_IMultiSourceFrameReference(long reference) {
		this.reference = reference;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(reference, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT AcquireFrame(
	         IMultiSourceFrame **frame
	)
	 */
	private class Arg_AcquireFrame extends Arg_property {
		private long[] frame;
		
		private Arg_AcquireFrame(long[] frame) {
			this.frame = frame;
		}
	}

	public int AcquireFrame(long[] frame) throws Exception_KINECT {
		Arg_AcquireFrame arg = new Arg_AcquireFrame(frame);

		int intRtn = JInvoker.callIntMethod(reference, IDX_AcquireFrame, arg);
		
		System.out.println("AcquireFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("AcquireFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("AcquireFrame");

		return intRtn;
	}

}
