package testkinectv2;

import utildll.*;

public class Wrp_INuiFusionColorMesh {
	private static final int CHARSET = Arg.UNICODE;
	private long mesh = 0;
	private static final int 
		IDX_QueryInterface = 0,
		IDX_AddRef = 1,
		IDX_Release = 2,
		IDX_VertexCount = 3,
		IDX_GetVertices = 4,
		IDX_NormalCount = 5,
		IDX_GetNormals = 6,
		IDX_TriangleVertexIndexCount = 7,
		IDX_GetTriangleIndices = 8,
		IDX_ColorCount = 9,
		IDX_GetColors = 10;
		
	public Wrp_INuiFusionColorMesh(long mesh) {
		this.mesh = mesh;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(mesh, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	UINT VertexCount()
	 */
	private class Arg_VertexCount extends Arg_property {
	}
	
	public int VertexCount() throws Exception_KINECT {
		Arg_VertexCount arg = new Arg_VertexCount();

		int intRtn = JInvoker.callIntMethod(mesh, IDX_VertexCount, arg);
		
		System.out.println("VertexCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("VertexCount");

		return intRtn;
	}
	
	/*
	HRESULT GetVertices(
	         const Vector3 **pVertices
	)
	 */
	private class Arg_GetVertices extends Arg_property {
		private long[] pVertices; // const Vector3 **
		
		Arg_GetVertices(long[] pVertices) {
			this.pVertices = pVertices;
		}
	}
	
	public int GetVertices(long[] pVertices) throws Exception_KINECT {
		Arg_GetVertices arg = new Arg_GetVertices(pVertices);

		int intRtn = JInvoker.callIntMethod(mesh, IDX_GetVertices, arg);
		
		System.out.println("GetVertices rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetVertices");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetVertices");

		return intRtn;
	}
	
	/*
	UINT TriangleVertexIndexCount()
	 */
	private class Arg_TriangleVertexIndexCount extends Arg_property {
	}
	
	public int TriangleVertexIndexCount() throws Exception_KINECT {
		Arg_TriangleVertexIndexCount arg = new Arg_TriangleVertexIndexCount();

		int intRtn = JInvoker.callIntMethod(mesh, IDX_TriangleVertexIndexCount, arg);
		
		System.out.println("TriangleVertexIndexCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("TriangleVertexIndexCount");

		return intRtn;
	}
	
	/*
	HRESULT GetTriangleIndices(
	         const int **pTriangleVertexIndices
	)
	 */
	private class Arg_GetTriangleIndices extends Arg_property {
		private long[] pTriangleVertexIndices; // const int **
		
		Arg_GetTriangleIndices(long[] pTriangleVertexIndices) {
			this.pTriangleVertexIndices = pTriangleVertexIndices;
		}
	}
	
	public int GetTriangleIndices(long[] pTriangleVertexIndices) throws Exception_KINECT {
		Arg_GetTriangleIndices arg = new Arg_GetTriangleIndices(pTriangleVertexIndices);

		int intRtn = JInvoker.callIntMethod(mesh, IDX_GetTriangleIndices, arg);
		
		System.out.println("GetTriangleIndices rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetTriangleIndices");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetTriangleIndices");

		return intRtn;
	}
	
	/*
	UINT ColorCount()
	 */
	private class Arg_ColorCount extends Arg_property {
	}
	
	public int ColorCount() throws Exception_KINECT {
		Arg_ColorCount arg = new Arg_ColorCount();

		int intRtn = JInvoker.callIntMethod(mesh, IDX_ColorCount, arg);
		
		System.out.println("ColorCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("ColorCount");

		return intRtn;
	}
	
	/*
	HRESULT GetColors(
	         const int **pColors
	)
	 */
	private class Arg_GetColors extends Arg_property {
		private long[] pColors; // const int **
		
		Arg_GetColors(long[] pColors) {
			this.pColors = pColors;
		}
	}
	
	public int GetColors(long[] pColors) throws Exception_KINECT {
		Arg_GetColors arg = new Arg_GetColors(pColors);

		int intRtn = JInvoker.callIntMethod(mesh, IDX_GetColors, arg);
		
		System.out.println("GetColors rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetColors");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetColors");

		return intRtn;
	}

}
