package testkinectv2;

import utildll.*;

public class Wrp_INuiFusionColorReconstruction {
	private static final int CHARSET = Arg.UNICODE;
	private long reconst = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_ResetReconstruction = 3,
			IDX_AlignDepthFloatToReconstruction = 4,
			IDX_GetCurrentWorldToCameraTransform = 5,
			IDX_GetCurrentWorldToVolumeTransform = 6,
			IDX_IntegrateFrame = 7,
			IDX_ProcessFrame = 8,
			IDX_CalculatePointCloud = 9,
			IDX_CalculateMesh = 10,
			IDX_ExportVolumeBlock = 11,
			IDX_ImportVolumeBlock = 12,
			IDX_DepthToDepthFloatFrame = 13,
			IDX_SmoothDepthFloatFrame = 14,
			IDX_AlignPointClouds = 15,
			IDX_SetAlignDepthFloatToReconstructionReferenceFrame = 16,
			IDX_CalculatePointCloudAndDepth = 17;
	
	public Wrp_INuiFusionColorReconstruction(long reconst) {
		this.reconst = reconst;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(reconst, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT ResetReconstruction(
	         const Matrix4 *pInitialWorldToCameraTransform,
	         const Matrix4 *pWorldToVolumeTransform
	)
	 */
	private class Arg_ResetReconstruction extends Arg_property {
		private @_Const Struct_Matrix4 pInitialWorldToCameraTransform;
		private @_Const Struct_Matrix4 pWorldToVolumeTransform;

		Arg_ResetReconstruction(Struct_Matrix4 pInitialWorldToCameraTransform,
				Struct_Matrix4 pWorldToVolumeTransform) {
			this.pInitialWorldToCameraTransform = pInitialWorldToCameraTransform;
			this.pWorldToVolumeTransform = pWorldToVolumeTransform;
		}
	}

	public int ResetReconstruction(Struct_Matrix4 pInitialWorldToCameraTransform,
			Struct_Matrix4 pWorldToVolumeTransform) throws Exception_KINECT {
		Arg_ResetReconstruction arg = new Arg_ResetReconstruction(pInitialWorldToCameraTransform,
				pWorldToVolumeTransform);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_ResetReconstruction, arg);
		
		System.out.println("ResetReconstruction rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("ResetReconstruction");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ResetReconstruction");

		return intRtn;
	}
	
	/*
	HRESULT GetCurrentWorldToCameraTransform(
	         Matrix4 *pWorldToCameraTransform
	)
	 */
	private class Arg_GetCurrentWorldToCameraTransform extends Arg_property {
		private Struct_Matrix4 pWorldToCameraTransform;

		Arg_GetCurrentWorldToCameraTransform(Struct_Matrix4 pWorldToCameraTransform) {
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	public int GetCurrentWorldToCameraTransform(Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_GetCurrentWorldToCameraTransform arg = new Arg_GetCurrentWorldToCameraTransform(
				pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_GetCurrentWorldToCameraTransform, arg);
		
		System.out.println("GetCurrentWorldToCameraTransform rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetCurrentWorldToCameraTransform");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetCurrentWorldToCameraTransform");

		return intRtn;
	}

	/*
	HRESULT ProcessFrame(
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         const NUI_FUSION_IMAGE_FRAME *pColorFrame,
	         USHORT maxAlignIterationCount,
	         USHORT maxIntegrationWeight,
	         FLOAT maxColorIntegrationAngle,
	         FLOAT *pAlignmentEnergy,
	         const Matrix4 *pWorldToCameraTransform
	)
	 */
	private class Arg_ProcessFrame extends Arg_property {
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private long pColorFrame; // const NUI_FUSION_IMAGE_FRAME *
		private short maxAlignIterationCount;
		private short maxIntegrationWeight;
		private float maxColorIntegrationAngle;
		private float[] pAlignmentEnergy;
		private @_Const Struct_Matrix4 pWorldToCameraTransform;

		Arg_ProcessFrame(long pDepthFloatFrame, long pColorFrame, short maxAlignIterationCount,
				short maxIntegrationWeight, float maxColorIntegrationAngle, float[] pAlignmentEnergy,
				Struct_Matrix4 pWorldToCameraTransform) {
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.pColorFrame = pColorFrame;
			this.maxAlignIterationCount = maxAlignIterationCount;
			this.maxIntegrationWeight = maxIntegrationWeight;
			this.maxColorIntegrationAngle = maxColorIntegrationAngle;
			this.pAlignmentEnergy = pAlignmentEnergy;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	public int ProcessFrame(long pDepthFloatFrame, long pColorFrame, short maxAlignIterationCount,
			short maxIntegrationWeight, float maxColorIntegrationAngle, float[] pAlignmentEnergy,
			Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_ProcessFrame arg = new Arg_ProcessFrame(pDepthFloatFrame, pColorFrame, 
				maxAlignIterationCount, maxIntegrationWeight, maxColorIntegrationAngle,
				pAlignmentEnergy, pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_ProcessFrame, arg);
		
		System.out.println("ProcessFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("ProcessFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_NuiKinectFusionApi.E_NUI_FUSION_TRACKING_ERROR)
				throw new Exception_KINECT("ProcessFrame");

		return intRtn;
	}

	/*
	HRESULT CalculatePointCloud(
	         const NUI_FUSION_IMAGE_FRAME *pPointCloudFrame,
	         const NUI_FUSION_IMAGE_FRAME *pColorFrame,
	         const Matrix4 *pWorldToCameraTransform
	)
	 */
	private class Arg_CalculatePointCloud extends Arg_property {
		private long pPointCloudFrame; // const NUI_FUSION_IMAGE_FRAME *
		private long pColorFrame; // const NUI_FUSION_IMAGE_FRAME *
		private @_Const Struct_Matrix4 pWorldToCameraTransform;

		Arg_CalculatePointCloud(long pPointCloudFrame, long pColorFrame,
				Struct_Matrix4 pWorldToCameraTransform) {
			this.pPointCloudFrame = pPointCloudFrame;
			this.pColorFrame = pColorFrame;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	public int CalculatePointCloud(long pPointCloudFrame, long pColorFrame, 
			Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_CalculatePointCloud arg = new Arg_CalculatePointCloud(pPointCloudFrame,
				pColorFrame, pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_CalculatePointCloud, arg);
		
		System.out.println("CalculatePointCloud rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CalculatePointCloud");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CalculatePointCloud");

		return intRtn;
	}

	/*
	HRESULT CalculateMesh(
	         UINT voxelStep,
	         INuiFusionColorMesh **ppMesh
	)
	 */
	private class Arg_CalculateMesh extends Arg_property {
		private int voxelStep;
		private long[] ppMesh; // INuiFusionColorMesh **

		Arg_CalculateMesh(int voxelStep, long[] ppMesh) {
			this.voxelStep = voxelStep;
			this.ppMesh = ppMesh;
		}
	}

	public int CalculateMesh(int voxelStep, long[] ppMesh) throws Exception_KINECT {
		Arg_CalculateMesh arg = new Arg_CalculateMesh(voxelStep, ppMesh);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_CalculateMesh, arg);
		
		System.out.println("CalculateMesh rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CalculateMesh");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CalculateMesh");

		return intRtn;
	}

	/*
	HRESULT DepthToDepthFloatFrame(
	         const UINT16 *pDepthImageData,
	         UINT countDepthImageDataBytes,
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         FLOAT minDepthClip,
	         FLOAT maxDepthClip,
	         BOOL mirrorDepth
	)
	 */
	private class Arg_DepthToDepthFloatFrame extends Arg_property {
		private short[] pDepthImageData;
		private int countDepthImageDataBytes;
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private float minDepthClip;
		private float maxDepthClip;
		private boolean mirrorDepth;

		Arg_DepthToDepthFloatFrame(short[] pDepthImageData, int countDepthImageDataBytes,
				long pDepthFloatFrame, float minDepthClip, float maxDepthClip, boolean mirrorDepth) {
			this.pDepthImageData = pDepthImageData;
			this.countDepthImageDataBytes = countDepthImageDataBytes;
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.minDepthClip = minDepthClip;
			this.maxDepthClip = maxDepthClip;
			this.mirrorDepth = mirrorDepth;
		}
	}
	
	public int DepthToDepthFloatFrame(short[] pDepthImageData, int countDepthImageDataBytes,
			long pDepthFloatFrame, float minDepthClip, float maxDepthClip,
			boolean mirrorDepth) throws Exception_KINECT {
		Arg_DepthToDepthFloatFrame arg = new Arg_DepthToDepthFloatFrame(pDepthImageData,
				countDepthImageDataBytes, pDepthFloatFrame, minDepthClip, maxDepthClip, mirrorDepth);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_DepthToDepthFloatFrame, arg);
		
		System.out.println("DepthToDepthFloatFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("DepthToDepthFloatFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("DepthToDepthFloatFrame");

		return intRtn;
	}

	/*
	HRESULT SmoothDepthFloatFrame(
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         const NUI_FUSION_IMAGE_FRAME *pSmoothDepthFloatFrame,
	         UINT kernelWidth,
	         FLOAT distanceThreshold
	)
	 */
	private class Arg_SmoothDepthFloatFrame extends Arg_property {
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private long pSmoothDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private int kernelWidth;
		private float distanceThreshold;

		Arg_SmoothDepthFloatFrame(long pDepthFloatFrame, long pSmoothDepthFloatFrame,
				int kernelWidth, float distanceThreshold) {
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.pSmoothDepthFloatFrame = pSmoothDepthFloatFrame;
			this.kernelWidth = kernelWidth;
			this.distanceThreshold = distanceThreshold;
		}
	}
	
	public int SmoothDepthFloatFrame(long pDepthFloatFrame, long pSmoothDepthFloatFrame,
			int kernelWidth, float distanceThreshold) throws Exception_KINECT {
		Arg_SmoothDepthFloatFrame arg = new Arg_SmoothDepthFloatFrame(pDepthFloatFrame,
				pSmoothDepthFloatFrame, kernelWidth, distanceThreshold);

		int intRtn = JInvoker.callIntMethod(reconst, IDX_SmoothDepthFloatFrame, arg);
		
		System.out.println("SmoothDepthFloatFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("SmoothDepthFloatFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SmoothDepthFloatFrame");

		return intRtn;
	}

}
