package testkinectv2;

import utildll.*;

public class Wrp_IVisualGestureBuilderFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_ContinuousGestureResult = 3,
			IDX_get_DiscreteGestureResult = 4,
			IDX_get_TrackingId = 5,
			IDX_get_IsTrackingIdValid = 6,
			IDX_get_RelativeTime = 7,
			IDX_get_VisualGestureBuilderFrameSource = 8;
	
	public Wrp_IVisualGestureBuilderFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_ContinuousGestureResult(
	         IGesture *gesture,
	         _COM_Outptr_result_maybenull_ IContinuousGestureResult **result
	)
	 */
	private class Arg_get_ContinuousGestureResult extends Arg_property {
		private long gesture;
		private long[] result;
		
		private Arg_get_ContinuousGestureResult(long gesture, long[] result) {
			this.gesture = gesture;
			this.result = result;
		}
	}

	public int get_ContinuousGestureResult(long gesture, long[] result) throws Exception_KINECT {
		Arg_get_ContinuousGestureResult arg = new Arg_get_ContinuousGestureResult(gesture, result);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_ContinuousGestureResult, arg);
		
		System.out.println("get_ContinuousGestureResult rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_ContinuousGestureResult");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_ContinuousGestureResult");

		return intRtn;
	}
	
	/*
	HRESULT get_DiscreteGestureResult(
	         IGesture *gesture,
	         _COM_Outptr_result_maybenull_ IDiscreteGestureResult **result
	)
	 */
	private class Arg_get_DiscreteGestureResult extends Arg_property {
		private long gesture;
		private long[] result;
		
		private Arg_get_DiscreteGestureResult(long gesture, long[] result) {
			this.gesture = gesture;
			this.result = result;
		}
	}

	public int get_DiscreteGestureResult(long gesture, long[] result) throws Exception_KINECT {
		Arg_get_DiscreteGestureResult arg = new Arg_get_DiscreteGestureResult(gesture, result);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_DiscreteGestureResult, arg);
		
		System.out.println("get_DiscreteGestureResult rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_DiscreteGestureResult");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_DiscreteGestureResult");

		return intRtn;
	}
	
	/*
	HRESULT get_IsTrackingIdValid(
	         BOOLEAN *isTrackingIdValid
	)
	 */
	private class Arg_get_IsTrackingIdValid extends Arg_property {
		private byte[] isTrackingIdValid;
		
		private Arg_get_IsTrackingIdValid(byte[] isTrackingIdValid) {
			this.isTrackingIdValid = isTrackingIdValid;
		}
	}

	public int get_IsTrackingIdValid(byte[] isTrackingIdValid) throws Exception_KINECT {
		Arg_get_IsTrackingIdValid arg = new Arg_get_IsTrackingIdValid(isTrackingIdValid);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_IsTrackingIdValid, arg);
		
		System.out.println("get_IsTrackingIdValid rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsTrackingIdValid");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsTrackingIdValid");

		return intRtn;
	}

}
