package testkinectv2;

import utildll.*;

public class Wrp_IVisualGestureBuilderFrameReader {
	private static final int CHARSET = Arg.UNICODE;
	private long reader = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeFrameArrived = 3,
			IDX_UnsubscribeFrameArrived = 4,
			IDX_GetFrameArrivedEventData = 5,
			IDX_CalculateAndAcquireLatestFrame = 6,
			IDX_get_IsPaused = 7,
			IDX_put_IsPaused = 8,
			IDX_get_VisualGestureBuilderFrameSource = 9;
	
	public Wrp_IVisualGestureBuilderFrameReader(long reader) {
		this.reader = reader;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(reader, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT CalculateAndAcquireLatestFrame(
	         IVisualGestureBuilderFrame **gestureFrame
	)
	 */
	private class Arg_CalculateAndAcquireLatestFrame extends Arg_property {
		private long[] gestureFrame;
		
		private Arg_CalculateAndAcquireLatestFrame(long[] gestureFrame) {
			this.gestureFrame = gestureFrame;
		}
	}

	public int CalculateAndAcquireLatestFrame(long[] gestureFrame) throws Exception_KINECT {
		Arg_CalculateAndAcquireLatestFrame arg = new Arg_CalculateAndAcquireLatestFrame(gestureFrame);

		int intRtn = JInvoker.callIntMethod(reader, IDX_CalculateAndAcquireLatestFrame, arg);
		
		System.out.println("CalculateAndAcquireLatestFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CalculateAndAcquireLatestFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_WinError.E_PENDING)
				throw new Exception_KINECT("CalculateAndAcquireLatestFrame");

		return intRtn;
	}

}
