package testkinectv2;

public class H_Kinect_Face {
	/*
enum _FacePointType
	    {
	        FacePointType_None	= -1,
	        FacePointType_EyeLeft	= 0,
	        FacePointType_EyeRight	= 1,
	        FacePointType_Nose	= 2,
	        FacePointType_MouthCornerLeft	= 3,
	        FacePointType_MouthCornerRight	= 4,
	        FacePointType_Count	= ( FacePointType_MouthCornerRight + 1 ) 
	    } ;
	 */
	static final int
	    FacePointType_None	            = -1,
	    FacePointType_EyeLeft	        = 0,
	    FacePointType_EyeRight	        = 1,
	    FacePointType_Nose	            = 2,
	    FacePointType_MouthCornerLeft	= 3,
	    FacePointType_MouthCornerRight	= 4,
	    FacePointType_Count	            = ( FacePointType_MouthCornerRight + 1 );
	
	/*
	enum _FaceFrameFeatures
	    {
	        FaceFrameFeatures_None	= 0,
	        FaceFrameFeatures_BoundingBoxInInfraredSpace	= 0x1,
	        FaceFrameFeatures_PointsInInfraredSpace	= 0x2,
	        FaceFrameFeatures_BoundingBoxInColorSpace	= 0x4,
	        FaceFrameFeatures_PointsInColorSpace	= 0x8,
	        FaceFrameFeatures_RotationOrientation	= 0x10,
	        FaceFrameFeatures_Happy	= 0x20,
	        FaceFrameFeatures_RightEyeClosed	= 0x40,
	        FaceFrameFeatures_LeftEyeClosed	= 0x80,
	        FaceFrameFeatures_MouthOpen	= 0x100,
	        FaceFrameFeatures_MouthMoved	= 0x200,
	        FaceFrameFeatures_LookingAway	= 0x400,
	        FaceFrameFeatures_Glasses	= 0x800,
	        FaceFrameFeatures_FaceEngagement	= 0x1000
	    } ;
	 */
	static final int
	    FaceFrameFeatures_None	                        = 0,
	    FaceFrameFeatures_BoundingBoxInInfraredSpace	= 0x1,
	    FaceFrameFeatures_PointsInInfraredSpace	        = 0x2,
	    FaceFrameFeatures_BoundingBoxInColorSpace	    = 0x4,
	    FaceFrameFeatures_PointsInColorSpace	        = 0x8,
	    FaceFrameFeatures_RotationOrientation	        = 0x10,
	    FaceFrameFeatures_Happy	                        = 0x20,
	    FaceFrameFeatures_RightEyeClosed	            = 0x40,
	    FaceFrameFeatures_LeftEyeClosed	                = 0x80,
	    FaceFrameFeatures_MouthOpen	                    = 0x100,
	    FaceFrameFeatures_MouthMoved	                = 0x200,
	    FaceFrameFeatures_LookingAway	                = 0x400,
	    FaceFrameFeatures_Glasses	                    = 0x800,
	    FaceFrameFeatures_FaceEngagement	            = 0x1000;
	
	/*
	enum _FaceProperty
	    {
	        FaceProperty_Happy	= 0,
	        FaceProperty_Engaged	= 1,
	        FaceProperty_WearingGlasses	= 2,
	        FaceProperty_LeftEyeClosed	= 3,
	        FaceProperty_RightEyeClosed	= 4,
	        FaceProperty_MouthOpen	= 5,
	        FaceProperty_MouthMoved	= 6,
	        FaceProperty_LookingAway	= 7,
	        FaceProperty_Count	= ( FaceProperty_LookingAway + 1 ) 
	    } ;
	 */
	static final int
	    FaceProperty_Happy	        = 0,
	    FaceProperty_Engaged	    = 1,
	    FaceProperty_WearingGlasses	= 2,
	    FaceProperty_LeftEyeClosed	= 3,
	    FaceProperty_RightEyeClosed	= 4,
	    FaceProperty_MouthOpen	    = 5,
	    FaceProperty_MouthMoved	    = 6,
	    FaceProperty_LookingAway	= 7,
	    FaceProperty_Count	        = ( FaceProperty_LookingAway + 1 );
	
	/*
	enum _FaceShapeDeformations
	    {
	        FaceShapeDeformations_PCA01	= 0,
	        FaceShapeDeformations_PCA02	= 1,
	        FaceShapeDeformations_PCA03	= 2,
	        FaceShapeDeformations_PCA04	= 3,
	        FaceShapeDeformations_PCA05	= 4,
	        FaceShapeDeformations_PCA06	= 5,
	        FaceShapeDeformations_PCA07	= 6,
	        FaceShapeDeformations_PCA08	= 7,
	        FaceShapeDeformations_PCA09	= 8,
	        FaceShapeDeformations_PCA10	= 9,
	        FaceShapeDeformations_Chin03	= 10,
	        FaceShapeDeformations_Forehead00	= 11,
	        FaceShapeDeformations_Cheeks02	= 12,
	        FaceShapeDeformations_Cheeks01	= 13,
	        FaceShapeDeformations_MouthBag01	= 14,
	        FaceShapeDeformations_MouthBag02	= 15,
	        FaceShapeDeformations_Eyes02	= 16,
	        FaceShapeDeformations_MouthBag03	= 17,
	        FaceShapeDeformations_Forehead04	= 18,
	        FaceShapeDeformations_Nose00	= 19,
	        FaceShapeDeformations_Nose01	= 20,
	        FaceShapeDeformations_Nose02	= 21,
	        FaceShapeDeformations_MouthBag06	= 22,
	        FaceShapeDeformations_MouthBag05	= 23,
	        FaceShapeDeformations_Cheeks00	= 24,
	        FaceShapeDeformations_Mask03	= 25,
	        FaceShapeDeformations_Eyes03	= 26,
	        FaceShapeDeformations_Nose03	= 27,
	        FaceShapeDeformations_Eyes08	= 28,
	        FaceShapeDeformations_MouthBag07	= 29,
	        FaceShapeDeformations_Eyes00	= 30,
	        FaceShapeDeformations_Nose04	= 31,
	        FaceShapeDeformations_Mask04	= 32,
	        FaceShapeDeformations_Chin04	= 33,
	        FaceShapeDeformations_Forehead05	= 34,
	        FaceShapeDeformations_Eyes06	= 35,
	        FaceShapeDeformations_Eyes11	= 36,
	        FaceShapeDeformations_Nose05	= 37,
	        FaceShapeDeformations_Mouth07	= 38,
	        FaceShapeDeformations_Cheeks08	= 39,
	        FaceShapeDeformations_Eyes09	= 40,
	        FaceShapeDeformations_Mask10	= 41,
	        FaceShapeDeformations_Mouth09	= 42,
	        FaceShapeDeformations_Nose07	= 43,
	        FaceShapeDeformations_Nose08	= 44,
	        FaceShapeDeformations_Cheeks07	= 45,
	        FaceShapeDeformations_Mask07	= 46,
	        FaceShapeDeformations_MouthBag09	= 47,
	        FaceShapeDeformations_Nose06	= 48,
	        FaceShapeDeformations_Chin02	= 49,
	        FaceShapeDeformations_Eyes07	= 50,
	        FaceShapeDeformations_Cheeks10	= 51,
	        FaceShapeDeformations_Rim20	= 52,
	        FaceShapeDeformations_Mask22	= 53,
	        FaceShapeDeformations_MouthBag15	= 54,
	        FaceShapeDeformations_Chin01	= 55,
	        FaceShapeDeformations_Cheeks04	= 56,
	        FaceShapeDeformations_Eyes17	= 57,
	        FaceShapeDeformations_Cheeks13	= 58,
	        FaceShapeDeformations_Mouth02	= 59,
	        FaceShapeDeformations_MouthBag12	= 60,
	        FaceShapeDeformations_Mask19	= 61,
	        FaceShapeDeformations_Mask20	= 62,
	        FaceShapeDeformations_Forehead06	= 63,
	        FaceShapeDeformations_Mouth13	= 64,
	        FaceShapeDeformations_Mask25	= 65,
	        FaceShapeDeformations_Chin05	= 66,
	        FaceShapeDeformations_Cheeks20	= 67,
	        FaceShapeDeformations_Nose09	= 68,
	        FaceShapeDeformations_Nose10	= 69,
	        FaceShapeDeformations_MouthBag27	= 70,
	        FaceShapeDeformations_Mouth11	= 71,
	        FaceShapeDeformations_Cheeks14	= 72,
	        FaceShapeDeformations_Eyes16	= 73,
	        FaceShapeDeformations_Mask29	= 74,
	        FaceShapeDeformations_Nose15	= 75,
	        FaceShapeDeformations_Cheeks11	= 76,
	        FaceShapeDeformations_Mouth16	= 77,
	        FaceShapeDeformations_Eyes19	= 78,
	        FaceShapeDeformations_Mouth17	= 79,
	        FaceShapeDeformations_MouthBag36	= 80,
	        FaceShapeDeformations_Mouth15	= 81,
	        FaceShapeDeformations_Cheeks25	= 82,
	        FaceShapeDeformations_Cheeks16	= 83,
	        FaceShapeDeformations_Cheeks18	= 84,
	        FaceShapeDeformations_Rim07	= 85,
	        FaceShapeDeformations_Nose13	= 86,
	        FaceShapeDeformations_Mouth18	= 87,
	        FaceShapeDeformations_Cheeks19	= 88,
	        FaceShapeDeformations_Rim21	= 89,
	        FaceShapeDeformations_Mouth22	= 90,
	        FaceShapeDeformations_Nose18	= 91,
	        FaceShapeDeformations_Nose16	= 92,
	        FaceShapeDeformations_Rim22	= 93,
	        FaceShapeDeformations_Count	= ( FaceShapeDeformations_Rim22 + 1 ) 
	    } ;
    	 */
	static final int
	    FaceShapeDeformations_PCA01			= 0,
	    FaceShapeDeformations_PCA02			= 1,
	    FaceShapeDeformations_PCA03			= 2,
	    FaceShapeDeformations_PCA04			= 3,
	    FaceShapeDeformations_PCA05			= 4,
	    FaceShapeDeformations_PCA06			= 5,
	    FaceShapeDeformations_PCA07			= 6,
	    FaceShapeDeformations_PCA08			= 7,
	    FaceShapeDeformations_PCA09			= 8,
	    FaceShapeDeformations_PCA10			= 9,
	    FaceShapeDeformations_Chin03		= 10,
	    FaceShapeDeformations_Forehead00	= 11,
	    FaceShapeDeformations_Cheeks02		= 12,
	    FaceShapeDeformations_Cheeks01		= 13,
	    FaceShapeDeformations_MouthBag01	= 14,
	    FaceShapeDeformations_MouthBag02	= 15,
	    FaceShapeDeformations_Eyes02		= 16,
	    FaceShapeDeformations_MouthBag03	= 17,
	    FaceShapeDeformations_Forehead04	= 18,
	    FaceShapeDeformations_Nose00		= 19,
	    FaceShapeDeformations_Nose01		= 20,
	    FaceShapeDeformations_Nose02		= 21,
	    FaceShapeDeformations_MouthBag06	= 22,
	    FaceShapeDeformations_MouthBag05	= 23,
	    FaceShapeDeformations_Cheeks00		= 24,
	    FaceShapeDeformations_Mask03		= 25,
	    FaceShapeDeformations_Eyes03		= 26,
	    FaceShapeDeformations_Nose03		= 27,
	    FaceShapeDeformations_Eyes08		= 28,
	    FaceShapeDeformations_MouthBag07	= 29,
	    FaceShapeDeformations_Eyes00		= 30,
	    FaceShapeDeformations_Nose04		= 31,
	    FaceShapeDeformations_Mask04		= 32,
	    FaceShapeDeformations_Chin04		= 33,
	    FaceShapeDeformations_Forehead05	= 34,
	    FaceShapeDeformations_Eyes06		= 35,
	    FaceShapeDeformations_Eyes11		= 36,
	    FaceShapeDeformations_Nose05		= 37,
	    FaceShapeDeformations_Mouth07		= 38,
	    FaceShapeDeformations_Cheeks08		= 39,
	    FaceShapeDeformations_Eyes09		= 40,
	    FaceShapeDeformations_Mask10		= 41,
	    FaceShapeDeformations_Mouth09		= 42,
	    FaceShapeDeformations_Nose07		= 43,
	    FaceShapeDeformations_Nose08		= 44,
	    FaceShapeDeformations_Cheeks07		= 45,
	    FaceShapeDeformations_Mask07		= 46,
	    FaceShapeDeformations_MouthBag09	= 47,
	    FaceShapeDeformations_Nose06		= 48,
	    FaceShapeDeformations_Chin02		= 49,
	    FaceShapeDeformations_Eyes07		= 50,
	    FaceShapeDeformations_Cheeks10		= 51,
	    FaceShapeDeformations_Rim20			= 52,
	    FaceShapeDeformations_Mask22		= 53,
	    FaceShapeDeformations_MouthBag15	= 54,
	    FaceShapeDeformations_Chin01		= 55,
	    FaceShapeDeformations_Cheeks04		= 56,
	    FaceShapeDeformations_Eyes17		= 57,
	    FaceShapeDeformations_Cheeks13		= 58,
	    FaceShapeDeformations_Mouth02		= 59,
	    FaceShapeDeformations_MouthBag12	= 60,
	    FaceShapeDeformations_Mask19		= 61,
	    FaceShapeDeformations_Mask20		= 62,
	    FaceShapeDeformations_Forehead06	= 63,
	    FaceShapeDeformations_Mouth13		= 64,
	    FaceShapeDeformations_Mask25		= 65,
	    FaceShapeDeformations_Chin05		= 66,
	    FaceShapeDeformations_Cheeks20		= 67,
	    FaceShapeDeformations_Nose09		= 68,
	    FaceShapeDeformations_Nose10		= 69,
	    FaceShapeDeformations_MouthBag27	= 70,
	    FaceShapeDeformations_Mouth11		= 71,
	    FaceShapeDeformations_Cheeks14		= 72,
	    FaceShapeDeformations_Eyes16		= 73,
	    FaceShapeDeformations_Mask29		= 74,
	    FaceShapeDeformations_Nose15		= 75,
	    FaceShapeDeformations_Cheeks11		= 76,
	    FaceShapeDeformations_Mouth16		= 77,
	    FaceShapeDeformations_Eyes19		= 78,
	    FaceShapeDeformations_Mouth17		= 79,
	    FaceShapeDeformations_MouthBag36	= 80,
	    FaceShapeDeformations_Mouth15		= 81,
	    FaceShapeDeformations_Cheeks25		= 82,
	    FaceShapeDeformations_Cheeks16		= 83,
	    FaceShapeDeformations_Cheeks18		= 84,
	    FaceShapeDeformations_Rim07			= 85,
	    FaceShapeDeformations_Nose13		= 86,
	    FaceShapeDeformations_Mouth18		= 87,
	    FaceShapeDeformations_Cheeks19		= 88,
	    FaceShapeDeformations_Rim21			= 89,
	    FaceShapeDeformations_Mouth22		= 90,
	    FaceShapeDeformations_Nose18		= 91,
	    FaceShapeDeformations_Nose16		= 92,
	    FaceShapeDeformations_Rim22			= 93,
	    FaceShapeDeformations_Count			= ( FaceShapeDeformations_Rim22 + 1 );

	/*
	enum _FaceModelBuilderCollectionStatus
	    {
	        FaceModelBuilderCollectionStatus_Complete	= 0,
	        FaceModelBuilderCollectionStatus_MoreFramesNeeded	= 0x1,
	        FaceModelBuilderCollectionStatus_FrontViewFramesNeeded	= 0x2,
	        FaceModelBuilderCollectionStatus_LeftViewsNeeded	= 0x4,
	        FaceModelBuilderCollectionStatus_RightViewsNeeded	= 0x8,
	        FaceModelBuilderCollectionStatus_TiltedUpViewsNeeded	= 0x10
	    } ;
	 */
	static final int
	    FaceModelBuilderCollectionStatus_Complete				= 0,
	    FaceModelBuilderCollectionStatus_MoreFramesNeeded		= 0x1,
	    FaceModelBuilderCollectionStatus_FrontViewFramesNeeded	= 0x2,
	    FaceModelBuilderCollectionStatus_LeftViewsNeeded		= 0x4,
	    FaceModelBuilderCollectionStatus_RightViewsNeeded		= 0x8,
	    FaceModelBuilderCollectionStatus_TiltedUpViewsNeeded	= 0x10;
	
	/*
	enum _FaceModelBuilderCaptureStatus
	    {
	        FaceModelBuilderCaptureStatus_GoodFrameCapture	= 0,
	        FaceModelBuilderCaptureStatus_OtherViewsNeeded	= 1,
	        FaceModelBuilderCaptureStatus_LostFaceTrack	= 2,
	        FaceModelBuilderCaptureStatus_FaceTooFar	= 3,
	        FaceModelBuilderCaptureStatus_FaceTooNear	= 4,
	        FaceModelBuilderCaptureStatus_MovingTooFast	= 5,
	        FaceModelBuilderCaptureStatus_SystemError	= 6
	    } ;
	 */
	static final int
	    FaceModelBuilderCaptureStatus_GoodFrameCapture	= 0,
	    FaceModelBuilderCaptureStatus_OtherViewsNeeded	= 1,
	    FaceModelBuilderCaptureStatus_LostFaceTrack		= 2,
	    FaceModelBuilderCaptureStatus_FaceTooFar		= 3,
	    FaceModelBuilderCaptureStatus_FaceTooNear		= 4,
	    FaceModelBuilderCaptureStatus_MovingTooFast		= 5,
	    FaceModelBuilderCaptureStatus_SystemError		= 6;
	
	/*
	enum _FaceModelBuilderAttributes
	    {
	        FaceModelBuilderAttributes_None	= 0,
	        FaceModelBuilderAttributes_SkinColor	= 0x1,
	        FaceModelBuilderAttributes_HairColor	= 0x2
	    } ;
	 */
	static final int
	    FaceModelBuilderAttributes_None			= 0,
	    FaceModelBuilderAttributes_SkinColor	= 0x1,
	    FaceModelBuilderAttributes_HairColor	= 0x2;
	
}
