package testkinectv2;

import utildll.*;

public class Wrp_IAudioBeamFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_AudioSource = 3,
			IDX_get_Duration = 4,
			IDX_get_AudioBeam = 5,
			IDX_get_SubFrameCount = 6,
			IDX_GetSubFrame = 7,
			IDX_get_RelativeTimeStart = 8;
	
	public Wrp_IAudioBeamFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT get_AudioBeam(
	         IAudioBeam **audioBeam
	)
	 */
	private class Arg_get_AudioBeam extends Arg_property {
		private long[] audioBeam;
		
		Arg_get_AudioBeam(long[] audioBeam) {
			this.audioBeam = audioBeam;
		}
	}
	
	public int get_AudioBeam(long[] audioBeam) throws Exception_KINECT {
		Arg_get_AudioBeam arg = new Arg_get_AudioBeam(audioBeam);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_AudioBeam, arg);
		
		System.out.println("get_AudioBeam rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_AudioBeam");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_AudioBeam");
		
		return intRtn;
	}

	/*
	HRESULT get_SubFrameCount(
	         UINT32 *pSubFrameCount
	)
	 */
	private class Arg_get_SubFrameCount extends Arg_property {
		private int[] pSubFrameCount;
		
		Arg_get_SubFrameCount(int[] pSubFrameCount) {
			this.pSubFrameCount = pSubFrameCount;
		}
	}
	
	public int get_SubFrameCount(int[] pSubFrameCount) throws Exception_KINECT {
		Arg_get_SubFrameCount arg = new Arg_get_SubFrameCount(pSubFrameCount);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_SubFrameCount, arg);
		
		System.out.println("get_SubFrameCount rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_SubFrameCount");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_SubFrameCount");
		
		return intRtn;
	}
	
	/*
	HRESULT GetSubFrame(
	         UINT32 subFrameIndex,
	         IAudioBeamSubFrame **audioBeamSubFrame
	)
	 */
	private class Arg_GetSubFrame extends Arg_property {
		private int subFrameIndex;
		private long[] audioBeamSubFrame;
		
		Arg_GetSubFrame(int subFrameIndex, long[] audioBeamSubFrame) {
			this.subFrameIndex = subFrameIndex;
			this.audioBeamSubFrame = audioBeamSubFrame;
		}
	}
	
	public int GetSubFrame(int subFrameIndex, long[] audioBeamSubFrame) throws Exception_KINECT {
		Arg_GetSubFrame arg = new Arg_GetSubFrame(subFrameIndex, audioBeamSubFrame);

		int intRtn = JInvoker.callIntMethod(frame, IDX_GetSubFrame, arg);
		
		System.out.println("GetSubFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetSubFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetSubFrame");
		
		return intRtn;
	}
	
}
