package testkinectv2;

import utildll.*;

public class Wrp_IAudioBeamFrameList {
	private static final int CHARSET = Arg.UNICODE;
	private long list = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_BeamCount = 3,
			IDX_OpenAudioBeamFrame = 4;
	
	public Wrp_IAudioBeamFrameList(long list) {
		this.list = list;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(list, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_BeamCount(
	         UINT *count
	)
	 */
	private class Arg_get_BeamCount extends Arg_property {
		private int[] count;
		
		private Arg_get_BeamCount(int[] count) {
			this.count = count;
		}
	}

	public int get_BeamCount(int[] count) throws Exception_KINECT {
		Arg_get_BeamCount arg = new Arg_get_BeamCount(count);

		int intRtn = JInvoker.callIntMethod(list, IDX_get_BeamCount, arg);
		
		System.out.println("get_BeamCount rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BeamCount");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BeamCount");

		return intRtn;
	}

	/*
	HRESULT OpenAudioBeamFrame(
	         UINT32 index,
	         IAudioBeamFrame **audioBeamFrame
	)
	 */
	private class Arg_OpenAudioBeamFrame extends Arg_property {
		private int index;
		private long[] audioBeamFrame;
		
		private Arg_OpenAudioBeamFrame(int index, long[] audioBeamFrame) {
			this.index = index;
			this.audioBeamFrame = audioBeamFrame;
		}
	}

	public int OpenAudioBeamFrame(int index, long[] audioBeamFrame) throws Exception_KINECT {
		Arg_OpenAudioBeamFrame arg = new Arg_OpenAudioBeamFrame(index, audioBeamFrame);

		int intRtn = JInvoker.callIntMethod(list, IDX_OpenAudioBeamFrame, arg);
		
		System.out.println("OpenAudioBeamFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("OpenAudioBeamFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("OpenAudioBeamFrame");

		return intRtn;
	}

}
