package testkinectv2;

import utildll.*;

public class Wrp_IAudioBeamFrameReader {
	private static final int CHARSET = Arg.UNICODE;
	private long reader = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeFrameArrived = 3,
			IDX_UnsubscribeFrameArrived = 4,
			IDX_GetFrameArrivedEventData = 5,
			IDX_AcquireLatestBeamFrames = 6,
			IDX_get_IsPaused = 7,
			IDX_put_IsPaused = 8,
			IDX_get_AudioSource = 9;
	
	public Wrp_IAudioBeamFrameReader(long reader) {
		this.reader = reader;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(reader, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT AcquireLatestBeamFrames(
	         IAudioBeamFrameList **audioBeamFrameList
	)
	 */
	private class Arg_AcquireLatestBeamFrames extends Arg_property {
		private long[] audioBeamFrameList;
		
		private Arg_AcquireLatestBeamFrames(long[] audioBeamFrameList) {
			this.audioBeamFrameList = audioBeamFrameList;
		}
	}

	public int AcquireLatestBeamFrames(long[] audioBeamFrameList) throws Exception_KINECT {
		Arg_AcquireLatestBeamFrames arg = new Arg_AcquireLatestBeamFrames(audioBeamFrameList);

		int intRtn = JInvoker.callIntMethod(reader, IDX_AcquireLatestBeamFrames, arg);
		
		System.out.println("AcquireLatestBeamFrames rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("AcquireLatestBeamFrames");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_WinError.E_PENDING)
				throw new Exception_KINECT("AcquireLatestBeamFrames");

		return intRtn;
	}

}
