package testkinectv2;

import utildll.*;

public class Wrp_IAudioBodyCorrelation {
	private static final int CHARSET = Arg.UNICODE;
	private long correlation = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_BodyTrackingId = 3;
	
	public Wrp_IAudioBodyCorrelation(long correlation) {
		this.correlation = correlation;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(correlation, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_BodyTrackingId(
	         UINT64 *trackingId
	)
	 */
	private class Arg_get_BodyTrackingId extends Arg_property {
		private long[] trackingId;
		
		private Arg_get_BodyTrackingId(long[] trackingId) {
			this.trackingId = trackingId;
		}
	}

	public int get_BodyTrackingId(long[] trackingId) throws Exception_KINECT {
		Arg_get_BodyTrackingId arg = new Arg_get_BodyTrackingId(trackingId);

		int intRtn = JInvoker.callIntMethod(correlation, IDX_get_BodyTrackingId, arg);
		
		System.out.println("get_BodyTrackingId rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BodyTrackingId");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BodyTrackingId");

		return intRtn;
	}

}
