package testkinectv2;

import utildll.*;

public class Wrp_IBodyFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_GetAndRefreshBodyData = 3,
			IDX_get_FloorClipPlane = 4,
			IDX_get_RelativeTime = 5,
			IDX_get_get_BodyFrameSource = 6;
	
	public Wrp_IBodyFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT GetAndRefreshBodyData(
	         UINT capacity,
	         IBody **bodies
	)
	 */
	private class Arg_GetAndRefreshBodyData extends Arg_property {
		private int capacity;
		private long[] bodies;
		
		Arg_GetAndRefreshBodyData(int capacity, long[] bodies) {
			this.capacity = capacity;
			this.bodies = bodies;
		}
	}
	
	public int GetAndRefreshBodyData(int capacity, long[] bodies) throws Exception_KINECT {
		Arg_GetAndRefreshBodyData arg = new Arg_GetAndRefreshBodyData(capacity, bodies);

		int intRtn = JInvoker.callIntMethod(frame, IDX_GetAndRefreshBodyData, arg);
		
		System.out.println("GetAndRefreshBodyData rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetAndRefreshBodyData");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetAndRefreshBodyData");
		
		return intRtn;
	}

}
