package testkinectv2;

import utildll.*;

public class Wrp_IContinuousGestureResult {
	private static final int CHARSET = Arg.UNICODE;
	private long result = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_Progress = 3;
	
	public Wrp_IContinuousGestureResult(long result) {
		this.result = result;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(result, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_Progress(
	         float *progress
	)
	 */
	private class Arg_get_Progress extends Arg_property {
		private float[] progress;
		
		private Arg_get_Progress(float[] progress) {
			this.progress = progress;
		}
	}

	public int get_Progress(float[] progress) throws Exception_KINECT {
		Arg_get_Progress arg = new Arg_get_Progress(progress);

		int intRtn = JInvoker.callIntMethod(result, IDX_get_Progress, arg);
		
		System.out.println("get_Progress rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Progress");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Progress");

		return intRtn;
	}

}
