package testkinectv2;

import utildll.*;

public class Wrp_IDiscreteGestureResult {
	private static final int CHARSET = Arg.UNICODE;
	private long result = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_Detected = 3,
			IDX_get_Confidence = 4,
			IDX_get_FirstFrameDetected = 5;
	
	public Wrp_IDiscreteGestureResult(long result) {
		this.result = result;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(result, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_Detected(
	         BOOLEAN *detected
	)
	 */
	private class Arg_get_Detected extends Arg_property {
		private byte[] detected;
		
		private Arg_get_Detected(byte[] detected) {
			this.detected = detected;
		}
	}

	public int get_Detected(byte[] detected) throws Exception_KINECT {
		Arg_get_Detected arg = new Arg_get_Detected(detected);

		int intRtn = JInvoker.callIntMethod(result, IDX_get_Detected, arg);
		
		System.out.println("get_Detected rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Detected");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Detected");

		return intRtn;
	}

	/*
	HRESULT get_Confidence(
	         float *confidence
	)
	 */
	private class Arg_get_Confidence extends Arg_property {
		private float[] confidence;
		
		private Arg_get_Confidence(float[] confidence) {
			this.confidence = confidence;
		}
	}

	public int get_Confidence(float[] confidence) throws Exception_KINECT {
		Arg_get_Confidence arg = new Arg_get_Confidence(confidence);

		int intRtn = JInvoker.callIntMethod(result, IDX_get_Confidence, arg);
		
		System.out.println("get_Confidence rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Confidence");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Confidence");

		return intRtn;
	}
	
}
