package testkinectv2;

import utildll.*;

public class Wrp_IFaceFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_FaceFrameResult = 3,
			IDX_get_TrackingId = 4,
			IDX_get_IsTrackingIdValid = 5,
			IDX_get_RelativeTime = 6,
			IDX_get_FaceFrameSource = 7,
			IDX_get_BodyFrameReference = 8,
			IDX_get_ColorFrameReference = 9,
			IDX_get_DepthFrameReference = 10,
			IDX_get_InfraredFrameReference = 11;
	
	public Wrp_IFaceFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_FaceFrameResult(
	         IFaceFrameResult **faceFrameResult
	)
	 */
	private class Arg_get_FaceFrameResult extends Arg_property {
		private long[] faceFrameResult;
		
		private Arg_get_FaceFrameResult(long[] faceFrameResult) {
			this.faceFrameResult = faceFrameResult;
		}
	}

	public int get_FaceFrameResult(long[] faceFrameResult) throws Exception_KINECT {
		Arg_get_FaceFrameResult arg = new Arg_get_FaceFrameResult(faceFrameResult);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_FaceFrameResult, arg);
		
		System.out.println("get_FaceFrameResult rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_FaceFrameResult");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_FaceFrameResult");

		return intRtn;
	}
	
	/*
	HRESULT get_IsTrackingIdValid(
	         BOOLEAN *isTrackingIdValid
	)
	 */
	private class Arg_get_IsTrackingIdValid extends Arg_property {
		private byte[] isTrackingIdValid;
		
		private Arg_get_IsTrackingIdValid(byte[] isTrackingIdValid) {
			this.isTrackingIdValid = isTrackingIdValid;
		}
	}

	public int get_IsTrackingIdValid(byte[] isTrackingIdValid) throws Exception_KINECT {
		Arg_get_IsTrackingIdValid arg = new Arg_get_IsTrackingIdValid(isTrackingIdValid);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_IsTrackingIdValid, arg);
		
		System.out.println("get_IsTrackingIdValid rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsTrackingIdValid");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsTrackingIdValid");

		return intRtn;
	}
	
}
