package testkinectv2;

import utildll.*;

public class Wrp_IFaceModel {
	private static final int CHARSET = Arg.UNICODE;
	private long model = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_Scale = 3,
			IDX_get_SkinColor = 4,
			IDX_get_HairColor = 5,
			IDX_GetFaceShapeDeformations = 6,
			IDX_CalculateVerticesForAlignment = 7;
	
	public Wrp_IFaceModel(long model) {
		this.model = model;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(model, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT CalculateVerticesForAlignment(
	         IFaceAlignment *faceAlignment,
	         UINT capacity,
	         CameraSpacePoint *vertices
	)
	 */
	private class Arg_CalculateVerticesForAlignment extends Arg_property {
		private long faceAlignment;
		private int capacity;
		private Struct_CameraSpacePoint[] vertices;
		
		private Arg_CalculateVerticesForAlignment(long faceAlignment, int capacity, Struct_CameraSpacePoint[] vertices) {
			this.faceAlignment = faceAlignment;
			this.capacity = capacity;
			this.vertices = vertices;
		}
	}

	public int CalculateVerticesForAlignment(long faceAlignment, int capacity, Struct_CameraSpacePoint[] vertices) throws Exception_KINECT {
		Arg_CalculateVerticesForAlignment arg = new Arg_CalculateVerticesForAlignment(faceAlignment, capacity, vertices);

		int intRtn = JInvoker.callIntMethod(model, IDX_CalculateVerticesForAlignment, arg);
		
		System.out.println("CalculateVerticesForAlignment rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CalculateVerticesForAlignment");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CalculateVerticesForAlignment");

		return intRtn;
	}

}
