package testkinectv2;

import utildll.*;

public class Wrp_IFrameDescription {
	private static final int CHARSET = Arg.UNICODE;
	private long description = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_Width = 3,
			IDX_get_Height = 4,
			IDX_get_HorizontalFieldOfView = 5,
			IDX_get_VerticalFieldOfView = 6,
			IDX_get_DiagonalFieldOfView = 7,
			IDX_get_LengthInPixels = 8,
			IDX_get_BytesPerPixel = 9;
	
	public Wrp_IFrameDescription(long description) {
		this.description = description;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(description, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_Width(
	         int *width
	)
	 */
	private class Arg_get_Width extends Arg_property {
		private int[] width;
		
		private Arg_get_Width(int[] width) {
			this.width = width;
		}
	}

	public int get_Width(int[] width) throws Exception_KINECT {
		Arg_get_Width arg = new Arg_get_Width(width);

		int intRtn = JInvoker.callIntMethod(description, IDX_get_Width, arg);
		
		System.out.println("get_Width rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Width");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Width");

		return intRtn;
	}
	
	/*
	HRESULT get_Height(
	         int *height
	)
	 */
	private class Arg_get_Height extends Arg_property {
		private int[] height;
		
		private Arg_get_Height(int[] height) {
			this.height = height;
		}
	}

	public int get_Height(int[] height) throws Exception_KINECT {
		Arg_get_Height arg = new Arg_get_Height(height);

		int intRtn = JInvoker.callIntMethod(description, IDX_get_Height, arg);
		
		System.out.println("get_Height rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Height");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Height");

		return intRtn;
	}
	
}
