package testkinectv2;

import utildll.*;

public class Wrp_IGesture {
	private static final int CHARSET = Arg.UNICODE;
	private long gesture = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_Name = 3,
			IDX_get_GestureType = 4;
	
	public Wrp_IGesture(long gesture) {
		this.gesture = gesture;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(gesture, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_Name(
	         UINT bufferSize,
	         wchar_t *gestureName
	)
	 */
	private class Arg_get_Name extends Arg_property {
		private int bufferSize;
		private @_Unicode String gestureName;
		
		private Arg_get_Name(int bufferSize) {
			this.bufferSize = bufferSize;
			StringBuffer sb = new StringBuffer(bufferSize);
			for (int i = 0; i < bufferSize; i++) {
				sb.append(' ');
			}
			this.gestureName = sb.toString();
		}
		
		private String get_gestureName() {return this.gestureName;};
	}

	public String get_Name(int bufferSize) throws Exception_KINECT {
		Arg_get_Name arg = new Arg_get_Name(bufferSize);

		int intRtn = JInvoker.callIntMethod(gesture, IDX_get_Name, arg);
		
		System.out.println("get_Name rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Name");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Name");

		return arg.get_gestureName();
	}
	
	/*
	HRESULT get_GestureType(
	         GestureType *gestureType
	)
	 */
	private class Arg_get_GestureType extends Arg_property {
		private int[] gestureType;
		
		private Arg_get_GestureType(int[] gestureType) {
			this.gestureType = gestureType;
		}
	}

	public int get_GestureType(int[] gestureType) throws Exception_KINECT {
		Arg_get_GestureType arg = new Arg_get_GestureType(gestureType);

		int intRtn = JInvoker.callIntMethod(gesture, IDX_get_GestureType, arg);
		
		System.out.println("get_GestureType rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_GestureType");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_GestureType");

		return intRtn;
	}
	
}
