package testkinectv2;

import utildll.*;

public class Wrp_IKinectPointerPoint {
	private static final int CHARSET = Arg.UNICODE;
	private long point = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_PointerDevice = 3,
			IDX_get_PointerId = 4,
			IDX_get_Position = 5,
			IDX_get_RawPosition = 6,
			IDX_get_Timestamp = 7,
			IDX_get_Properties = 8;
	
	public Wrp_IKinectPointerPoint(long point) {
		this.point = point;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(point, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_Position(
	         PointF *position
	)
	 */
	private class Arg_get_Position extends Arg_property {
		private Struct_PointF position;
		
		private Arg_get_Position(Struct_PointF position) {
			this.position = position;
		}
	}

	public int get_Position(Struct_PointF position) throws Exception_KINECT {
		Arg_get_Position arg = new Arg_get_Position(position);

		int intRtn = JInvoker.callIntMethod(point, IDX_get_Position, arg);
		
		System.out.println("get_Position rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Position");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Position");

		return intRtn;
	}
	
	/*
	HRESULT get_Properties(
	         IKinectPointerPointProperties **ppProperties
	)
	 */
	private class Arg_get_Properties extends Arg_property {
		private long[] ppProperties;
		
		private Arg_get_Properties(long[] ppProperties) {
			this.ppProperties = ppProperties;
		}
	}

	public int get_Properties(long[] ppProperties) throws Exception_KINECT {
		Arg_get_Properties arg = new Arg_get_Properties(ppProperties);

		int intRtn = JInvoker.callIntMethod(point, IDX_get_Properties, arg);
		
		System.out.println("get_Properties rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Properties");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Properties");

		return intRtn;
	}

}