package testkinectv2;

import utildll.*;

public class Wrp_IMultiSourceFrame {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_ColorFrameReference = 3,
			IDX_get_DepthFrameReference = 4,
			IDX_get_BodyFrameReference = 5,
			IDX_get_BodyIndexFrameReference = 6,
			IDX_get_InfraredFrameReference = 7,
			IDX_get_LongExposureInfraredFrameReference = 8;
	
	public Wrp_IMultiSourceFrame(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT get_ColorFrameReference(
	         IColorFrameReference **colorFrameReference
	)
	 */
	private class Arg_get_ColorFrameReference extends Arg_property {
		private long[] colorFrameReference;
		
		private Arg_get_ColorFrameReference(long[] colorFrameReference) {
			this.colorFrameReference = colorFrameReference;
		}
	}

	public int get_ColorFrameReference(long[] colorFrameReference) throws Exception_KINECT {
		Arg_get_ColorFrameReference arg = new Arg_get_ColorFrameReference(colorFrameReference);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_ColorFrameReference, arg);
		
		System.out.println("get_ColorFrameReference rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_ColorFrameReference");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_ColorFrameReference");

		return intRtn;
	}

	/*
	HRESULT get_DepthFrameReference(
	         IDepthFrameReference **depthFrameReference
	)
	 */
	private class Arg_get_DepthFrameReference extends Arg_property {
		private long[] depthFrameReference;
		
		private Arg_get_DepthFrameReference(long[] depthFrameReference) {
			this.depthFrameReference = depthFrameReference;
		}
	}

	public int get_DepthFrameReference(long[] depthFrameReference) throws Exception_KINECT {
		Arg_get_DepthFrameReference arg = new Arg_get_DepthFrameReference(depthFrameReference);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_DepthFrameReference, arg);
		
		System.out.println("get_DepthFrameReference rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_DepthFrameReference");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_DepthFrameReference");

		return intRtn;
	}
	
	/*
	HRESULT get_BodyIndexFrameReference(
	         IBodyIndexFrameReference **bodyIndexFrameReference
	)
	 */
	private class Arg_get_BodyIndexFrameReference extends Arg_property {
		private long[] bodyIndexFrameReference;
		
		private Arg_get_BodyIndexFrameReference(long[] bodyIndexFrameReference) {
			this.bodyIndexFrameReference = bodyIndexFrameReference;
		}
	}

	public int get_BodyIndexFrameReference(long[] bodyIndexFrameReference) throws Exception_KINECT {
		Arg_get_BodyIndexFrameReference arg = new Arg_get_BodyIndexFrameReference(bodyIndexFrameReference);

		int intRtn = JInvoker.callIntMethod(frame, IDX_get_BodyIndexFrameReference, arg);
		
		System.out.println("get_BodyIndexFrameReference rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BodyIndexFrameReference");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BodyIndexFrameReference");

		return intRtn;
	}
	
	
}
