package testkinectv2;

import utildll.*;

public class Wrp_IMultiSourceFrameArrivedEventArgs {
	private static final int CHARSET = Arg.UNICODE;
	private long args = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_FrameReference = 3;
	
	public Wrp_IMultiSourceFrameArrivedEventArgs(long args) {
		this.args = args;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(args, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_FrameReference(
	         IMultiSourceFrameReference **frames
	)
	 */
	private class Arg_get_FrameReference extends Arg_property {
		private long[] frames;
		
		private Arg_get_FrameReference(long[] frames) {
			this.frames = frames;
		}
	}

	public int get_FrameReference(long[] frames) throws Exception_KINECT {
		Arg_get_FrameReference arg = new Arg_get_FrameReference(frames);

		int intRtn = JInvoker.callIntMethod(args, IDX_get_FrameReference, arg);
		
		System.out.println("get_FrameReference rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_FrameReference");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_FrameReference");

		return intRtn;
	}

}
