package testkinectv2;

import utildll.*;

public class Wrp_IVisualGestureBuilderDatabase {
	private static final int CHARSET = Arg.UNICODE;
	private long database = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_AvailableGesturesCount = 3,
			IDX_get_AvailableGestures = 4;
	
	public Wrp_IVisualGestureBuilderDatabase(long database) {
		this.database = database;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(database, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT get_AvailableGesturesCount(
	         UINT *numGestures
	)
	 */
	private class Arg_get_AvailableGesturesCount extends Arg_property {
		private int[] numGestures;
		
		private Arg_get_AvailableGesturesCount(int[] numGestures) {
			this.numGestures = numGestures;
		}
	}

	public int get_AvailableGesturesCount(int[] numGestures) throws Exception_KINECT {
		Arg_get_AvailableGesturesCount arg = new Arg_get_AvailableGesturesCount(numGestures);

		int intRtn = JInvoker.callIntMethod(database, IDX_get_AvailableGesturesCount, arg);
		
		System.out.println("get_AvailableGesturesCount rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_AvailableGesturesCount");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_AvailableGesturesCount");

		return intRtn;
	}

	/*
	HRESULT get_AvailableGestures(
	         UINT32 capacity,
	         IGesture **availableGestures
	)
	 */
	private class Arg_get_AvailableGestures extends Arg_property {
		private int capacity;
		private long[] availableGestures;
		
		private Arg_get_AvailableGestures(int capacity, long[] availableGestures) {
			this.capacity = capacity;
			this.availableGestures = availableGestures;
		}
	}

	public int get_AvailableGestures(int capacity, long[] availableGestures) throws Exception_KINECT {
		Arg_get_AvailableGestures arg = new Arg_get_AvailableGestures(capacity, availableGestures);

		int intRtn = JInvoker.callIntMethod(database, IDX_get_AvailableGestures, arg);
		
		System.out.println("get_AvailableGestures rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_AvailableGestures");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_AvailableGestures");

		return intRtn;
	}

}
