package testkinectv2;

import utildll.*;

public class Wrp_IVisualGestureBuilderFrameSource {
	private static final int CHARSET = Arg.UNICODE;
	private long source = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeTrackingIdLost = 3,
			IDX_UnsubscribeTrackingIdLost = 4,
			IDX_GetTrackingIdLostEventData = 5,
			IDX_get_IsActive = 6,
			IDX_get_TrackingId = 7,
			IDX_put_TrackingId = 8,
			IDX_get_IsTrackingIdValid = 9,
			IDX_get_HorizontalMirror = 10,
			IDX_put_HorizontalMirror = 11,
			IDX_get_GestureCount = 12,
			IDX_get_Gestures = 13,
			IDX_AddGesture = 14,
			IDX_AddGestures = 15,
			IDX_RemoveGesture = 16,
			IDX_GetIsEnabled = 17,
			IDX_SetIsEnabled = 18,
			IDX_OpenReader = 19,
			IDX_get_KinectSensor = 20;
	
	public Wrp_IVisualGestureBuilderFrameSource(long source) {
		this.source = source;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(source, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT put_TrackingId(
	         UINT64 trackingId
	)
	 */
	private class Arg_put_TrackingId extends Arg_property {
		private long trackingId;
		
		private Arg_put_TrackingId(long trackingId) {
			this.trackingId = trackingId;
		}
	}

	public int put_TrackingId(long trackingId) throws Exception_KINECT {
		Arg_put_TrackingId arg = new Arg_put_TrackingId(trackingId);

		int intRtn = JInvoker.callIntMethod(source, IDX_put_TrackingId, arg);
		
		System.out.println("put_TrackingId rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("put_TrackingId");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("put_TrackingId");

		return intRtn;
	}

	/*
	HRESULT get_IsTrackingIdValid(
	         BOOLEAN *isValid
	)
	 */
	private class Arg_get_IsTrackingIdValid extends Arg_property {
		private byte[] isValid;
		
		private Arg_get_IsTrackingIdValid(byte[] isValid) {
			this.isValid = isValid;
		}
	}

	public int get_IsTrackingIdValid(byte[] isValid) throws Exception_KINECT {
		Arg_get_IsTrackingIdValid arg = new Arg_get_IsTrackingIdValid(isValid);

		int intRtn = JInvoker.callIntMethod(source, IDX_get_IsTrackingIdValid, arg);
		
		System.out.println("get_IsTrackingIdValid rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsTrackingIdValid");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsTrackingIdValid");

		return intRtn;
	}
	
	/*
	HRESULT AddGesture(
	         IGesture *gesture
	)
	 */
	private class Arg_AddGesture extends Arg_property {
		private long gesture;
		
		private Arg_AddGesture(long gesture) {
			this.gesture = gesture;
		}
	}

	public int AddGesture(long gesture) throws Exception_KINECT {
		Arg_AddGesture arg = new Arg_AddGesture(gesture);

		int intRtn = JInvoker.callIntMethod(source, IDX_AddGesture, arg);
		
		System.out.println("AddGesture rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("AddGesture");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("AddGesture");

		return intRtn;
	}
	
	/*
	HRESULT SetIsEnabled(
	         IGesture *gesture,
	         BOOLEAN isEnabled
	)
	 */
	private class Arg_SetIsEnabled extends Arg_property {
		private long gesture;
		private byte isEnabled;
		
		private Arg_SetIsEnabled(long gesture, byte isEnabled) {
			this.gesture = gesture;
			this.isEnabled = isEnabled;
		}
	}

	public int SetIsEnabled(long gesture, byte isEnabled) throws Exception_KINECT {
		Arg_SetIsEnabled arg = new Arg_SetIsEnabled(gesture, isEnabled);

		int intRtn = JInvoker.callIntMethod(source, IDX_SetIsEnabled, arg);
		
		System.out.println("SetIsEnabled rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("SetIsEnabled");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SetIsEnabled");

		return intRtn;
	}
	
	/*
	HRESULT OpenReader(
	         IVisualGestureBuilderFrameReader **reader
	)
	 */
	private class Arg_OpenReader extends Arg_property {
		private long[] reader;
		
		private Arg_OpenReader(long[] reader) {
			this.reader = reader;
		}
	}

	public int OpenReader(long[] reader) throws Exception_KINECT {
		Arg_OpenReader arg = new Arg_OpenReader(reader);

		int intRtn = JInvoker.callIntMethod(source, IDX_OpenReader, arg);
		
		System.out.println("OpenReader rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("OpenReader");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("OpenReader");

		return intRtn;
	}


}
